@ECHO OFF
CLS

REM -------------------------------------------------------------------
REM ! Datensicherung der GENprofi Daten mit PKZIP                     !
REM !                                                                 !
REM ! Autor      : Heiko Thimm                                        !
REM ! Datum      : 20-09-05                                           !
REM ! Version    : 02                                                 !
REM -------------------------------------------------------------------

REM berprfung der Parameter
REM -------------------------
REM Parameter  Beschreibung
REM
REM    1       Mandant
REM    2       Datenpfad, mu mit "\" enden
REM    3       Programmpfad Utilities, leer oder mu mit "\" enden
REM
IF "%1" == ""  GOTO ERR_PARA
IF "%2" == ""  GOTO ERR_PARA

REM berprfung der Programmumgebung
IF NOT EXIST %3SBTKEY.EXE                GOTO ERR_KEY
IF NOT EXIST %3SBT!DEL.EXE               GOTO ERR_KEY
IF NOT EXIST %3PKZIP.EXE                 GOTO ERR_LH

REM berprfung Datenbestand ...
IF NOT EXIST %2????_%1.DBF               GOTO ERR_DATA
IF NOT EXIST %2????_%1.FPT               GOTO ERR_DATA

ECHO Ŀ
ECHO DATENSICHERUNG                                    GENprofi GPFAM
ECHO Ĵ
ECHO Beachten Sie bitte, da bei dieser Sicherung immer nur ein      
ECHO Mandant auf gesichert wird!                                     
ECHO 
ECHO Mandant            : %1
ECHO Dateien            : %2????_%1.DBF
ECHO                    : %2????_%1.FPT
ECHO Sicherungsprogramm : %3PKZIP.EXE
ECHO Ŀ
ECHO  [ESC] - Abbruch                                                
ECHO 
ECHO 
%3SBTKEY

IF ERRORLEVEL 28 GOTO CHK_DISK
IF ERRORLEVEL 27 GOTO ENDE

:CHK_DISK
CLS
ECHO Bitte warten ...

:SAVE_DATA
%3SBT!DEL backup\GPFAM_%1.zip > NUL
REM Wenn man Austauschmedien (Disketten) verwendet, dann folgenden Befehl
REM %3pkzip backup\GPFAM_%1 -^ -o -&fv -P %2????_%1.DBF %2????_%1.FPT
%3pkzip backup\GPFAM_%1 -^ -o  -P %2????_%1.DBF %2????_%1.FPT

REM ERROR_LEVEL berprfung
IF ERRORLEVEL 1 GOTO ERR_LH_X

CALL gpf_cs backup\GPFAM_%1.zip  %3

GOTO ENDE

REM Fehlerbedingungen
:ERR_KEY
REM -------------------------------------------------------------------
REM                           Tastaturabfrageprogramm nicht vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Programm SBTKEY.EXE oder SBT!DEL.EXE fehlt.                     
ECHO                                                                 
ECHO Installation berprfen!                                        
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_LH
REM -------------------------------------------------------------------
REM                              Kompressionsprogramm nicht vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Programm PKZIP.EXE fehlt.  Installation berprfen!             
ECHO                                                                 
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_LH_X
REM -------------------------------------------------------------------
REM                                             Datensicherungsfehler !
REM -------------------------------------------------------------------
REM Bildschirm wird vor der Anzeige nicht gelscht, damit
REM die eventuellen Fehlermeldungen erhalten bleiben !
REM -------------------------------------------------------------------
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Bei der Programmausfhrung ist ein Fehler aufgetreten!          
ECHO                                                                 
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_PARA
REM -------------------------------------------------------------------
REM                                                   Parameterfehler !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Die Sicherungsroutine ist falsch aufgerufen worden! berprfen  
ECHO Sie bitte die Installation!                                     
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_DATA
REM -------------------------------------------------------------------
REM                               keine Daten zur Sicherung vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Der angegebene Mandant ist im Datenverzeichnis nicht vorhanden! 
ECHO berprfen Sie bitte die Installation!                          
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ENDE
