@ECHO OFF
CLS

REM -------------------------------------------------------------------
REM ! Datenrcksicherung der GENprofi Daten mit TAR und BZIP2         !
REM !                                                                 !
REM ! Autor      : Heiko Thimm                                        !
REM ! Datum      : 20-09-05                                           !
REM ! Version    : 02                                                 !
REM -------------------------------------------------------------------

REM berprfung der Parameter
REM -------------------------
REM Parameter  Beschreibung
REM
REM    1       Mandant
REM    2       Datenpfad, mu mit "\" enden
REM    3       Programmpfad Utilities, leer oder mu mit "\" enden
REM

IF "%1" == ""  GOTO ERR_PARA
IF "%2" == ""  GOTO ERR_PARA

REM berprfung der Programmumgebung
IF NOT EXIST %3SBTKEY.EXE                GOTO ERR_UTIL
IF NOT EXIST %3SBT!DEL.EXE               GOTO ERR_UTIL
IF NOT EXIST %3SBT!DIR.EXE               GOTO ERR_UTIL
IF NOT EXIST %3BZIP2.EXE                 GOTO ERR_UTIL
IF NOT EXIST %3BZIP2.DLL                 GOTO ERR_UTIL
IF NOT EXIST %3TAR.EXE                   GOTO ERR_UTIL

call gpf_cr.bat gpfam_%1.bz2  %3
IF NOT EXIST backup\gpfam_%1.bz2           GOTO ERR_GPFAM

CLS
ECHO Ŀ
ECHO DATENRCKSICHERUNG                                GENprofi GPFAM
ECHO Ĵ
ECHO Die Rcksicherung erfolgt aus dem Verzeichnis BACKUP Ihrer      
ECHO GENprofi Installation.                                          
ECHO 
ECHO Mandant            : %1
ECHO Datei              : gpfam_%1.bz2
ECHO Sicherungsprogramm : %3TAR.EXE
ECHO Komprimierung      : %3BZIP2.EXE
ECHO Ŀ
ECHO Weiter mit Tastendruck ...                                      
ECHO Ĵ
ECHO  [ESC] - Abbruch                                                
ECHO 
ECHO 
%3SBTKEY

IF ERRORLEVEL 28 GOTO REST_01
IF ERRORLEVEL 27 GOTO ENDE

:REST_01
CLS
ECHO Bitte warten ...

REM Lschen des vorhandenen Datenbestandes ...
IF EXIST %2????_%1.DBF        DEL %2????_%1.DBF > NUL
IF EXIST %2????_%1.FPT        DEL %2????_%1.FPT > NUL
IF EXIST %2????_%1.CDX        DEL %2????_%1.CDX > NUL

%3bunzip2 -f -k backup\gpfam_%1.bz2
IF ERRORLEVEL 1 GOTO ERR_X

%3tar -x  --file backup\gpfam_%1

REM ERROR_LEVEL berprfung
IF ERRORLEVEL 1 GOTO ERR_LH_X

IF EXIST backup\gpfam_%1    %3SBT!DEL backup\gpfam_%1 > NUL

XCOPY backup\data%1\*.* daten\*.* /V /Y > NUL
%3SBT!DEL backup\data%1\*.* > NUL
%3SBT!DIR R backup\data%1 > NUL

GOTO ENDE

REM Fehlerbedingungen
:ERR_UTIL
REM -------------------------------------------------------------------
REM                                    Hilfsprogramme nicht vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO Bentigte Hilfsprogramme fehlen!                                
ECHO 
ECHO Pfad fr Hilfsprogramme: %3
ECHO Ŀ
ECHO Programme: TAR.EXE  BZIP2.EXE BZIP2.DLL RM.EXE SBTKEY.EXE       
ECHO            BUNZIP2.EXE                                          
ECHO Installation berprfen!                                        
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_LH_X
REM -------------------------------------------------------------------
REM                                             Datensicherungsfehler !
REM -------------------------------------------------------------------

ECHO Ŀ
ECHO DATENRCKSICHERUNG    *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Bei der Programmausfhrung ist ein Fehler aufgetreten!          
ECHO                                                                 
ECHO                                                                 
ECHO          RCKSICHERUNG IST NICHT DURCHGEFHRT WORDEN !          
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_GPFAM
REM -------------------------------------------------------------------
REM                              Datensicherungsdatei nicht vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENRCKSICHERUNG    *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Auf der Diskette ist die Datensicherungsdatei nicht vorhanden!  
ECHO                                                                 
ECHO Datei : backup\GPFAM_%1.tar.bz2                                 
ECHO                                                                 
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_PARA
REM -------------------------------------------------------------------
REM                                                   Parameterfehler !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Die Sicherungsroutine ist falsch aufgerufen worden! berprfen  
ECHO Sie bitte die Installation!                                     
ECHO                                                                 
ECHO           RCKSICHERUNG IST NICHT DURCHGEFHRT WORDEN !         
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_COPY
CLS
REM -------------------------------------------------------------------
REM -------------------------------------------------------------------
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Beim Kopieren der Sicherungsdatei ist ein Fehler aufgetreten!   
ECHO                                                                 
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_CFILE
CLS
REM -------------------------------------------------------------------
REM -------------------------------------------------------------------
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Sicherungsdatei existiert nicht auf dem Laufwerk!               
ECHO                                                                 
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ENDE



