@ECHO OFF
CLS

REM -------------------------------------------------------------------
REM ! Datensicherung der GENprofi Daten mit TAR und BZIP2             !
REM !                                                                 !
REM ! Autor      : Heiko Thimm                                        !
REM ! Datum      : 20-09-05                                           !
REM ! Version    : 02                                                 !
REM -------------------------------------------------------------------

REM berprfung der Parameter
REM -------------------------
REM Parameter  Beschreibung
REM
REM    1       Mandant
REM    2       Datenpfad, mu mit "\" enden
REM    3       Programmpfad Utilities, leer oder mu mit "\" enden
REM
IF "%1" == ""  GOTO ERR_PARA
IF "%2" == ""  GOTO ERR_PARA

REM berprfung der Programmumgebung
IF NOT EXIST %3SBTKEY.EXE                GOTO ERR_UTIL
IF NOT EXIST %3SBT!DEL.EXE               GOTO ERR_UTIL
IF NOT EXIST %3BZIP2.EXE                 GOTO ERR_UTIL
IF NOT EXIST %3BZIP2.DLL                 GOTO ERR_UTIL
IF NOT EXIST %3TAR.EXE                   GOTO ERR_UTIL
IF NOT EXIST %3SBT!DIR.EXE               GOTO ERR_UTIL

REM berprfung Datenbestand ...
IF NOT EXIST %2????_%1.DBF               GOTO ERR_DATA
IF NOT EXIST %2????_%1.FPT               GOTO ERR_DATA

ECHO Ŀ
ECHO DATENSICHERUNG                                    GENprofi GPFAM
ECHO Ĵ
ECHO Die Sicherung erfolgt in das Verzeichnis BACKUP Ihrer GENprofi  
ECHO Installation. Die Erstellung von Kopien auf Sicherungsmedien    
ECHO mssen Sie manuell durchfhren.                                 
ECHO 
ECHO Mandant            : %1
ECHO Dateien            : %2????_%1.*
ECHO Sicherungsprogramm : %3TAR.EXE
ECHO Komprimierung      : %3BZIP2.EXE
ECHO Ŀ
ECHO  [ESC] - Abbruch                                                
ECHO 
ECHO 
%3SBTKEY

IF ERRORLEVEL 28 GOTO SAVE_DATA
IF ERRORLEVEL 27 GOTO ENDE

:SAVE_DATA
CLS
ECHO Bitte warten ...
ECHO Erstellung einer Kopie ...
%3sbt!del backup\gpfam_%1.bz2 > NUL
%3sbt!del backup\gpfam_%1 > NUL
%3sbt!del backup\data%1\*.*  > NUL
%3sbt!dir M backup\data%1 > NUL
xcopy %2????_%1.* backup\data%1 /V > NUL
REM ERROR_LEVEL berprfung
IF ERRORLEVEL 1 GOTO ERR_X

ECHO Erstellung einer Zusammenfassung ...
%3tar -c --verify --label GP4_MANDANT_%1 --file backup\gpfam_%1 backup\data%1
REM ERROR_LEVEL berprfung
IF ERRORLEVEL 1 GOTO ERR_X

ECHO Komprimierung ...
%3bzip2 -f backup\gpfam_%1

IF ERRORLEVEL 1 GOTO ERR_X

%3sbt!del backup\data%1\*.*  > NUL
%3sbt!dir R backup\data%1    > NUL

CALL gpf_cs backup\gpfam_%1.bz2  %3

GOTO ENDE


REM Fehlerbedingungen
:ERR_UTIL
REM -------------------------------------------------------------------
REM                                    Hilfsprogramme nicht vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO Bentigte Hilfsprogramme fehlen!                                
ECHO                                                                 
ECHO Pfad fr Hilfsprogramme: %3                                     
ECHO                                                                 
ECHO Programme: TAR.EXE  BZIP2.EXE BZIP2.DLL RM.EXE SBTKEY.EXE       
ECHO            BUNZIP2.EXE                                          
ECHO                                                                 
ECHO Installation berprfen!                                        
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_X
REM -------------------------------------------------------------------
REM                                             Datensicherungsfehler !
REM -------------------------------------------------------------------
REM Bildschirm wird vor der Anzeige nicht gelscht, damit
REM die eventuellen Fehlermeldungen erhalten bleiben !
REM -------------------------------------------------------------------
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Bei der Programmausfhrung ist ein Fehler aufgetreten!          
ECHO                                                                 
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_COPY
REM -------------------------------------------------------------------
REM                                             Datensicherungsfehler !
REM -------------------------------------------------------------------
REM Bildschirm wird vor der Anzeige nicht gelscht, damit
REM die eventuellen Fehlermeldungen erhalten bleiben !
REM -------------------------------------------------------------------
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Beim Kopieren der Sicherungsdatei ist ein Fehler aufgetreten!   
ECHO                                                                 
ECHO Die im Verzeichnis backup enthaltene Sicherungsdatei ist        
ECHO manuell zu kopieren!                                            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ERR_PARA
REM -------------------------------------------------------------------
REM                                                   Parameterfehler !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Die Sicherungsroutine ist falsch aufgerufen worden! berprfen  
ECHO Sie bitte die Installation!                                     
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE


:ERR_DATA
REM -------------------------------------------------------------------
REM                               keine Daten zur Sicherung vorhanden !
REM -------------------------------------------------------------------
CLS
ECHO Ŀ
ECHO DATENSICHERUNG        *** FEHLER ***              GENprofi GPFAM
ECHO Ĵ
ECHO                                                                 
ECHO Der angegebene Mandant ist im Datenverzeichnis nicht vorhanden! 
ECHO berprfen Sie bitte die Installation!                          
ECHO                                                                 
ECHO            SICHERUNG IST NICHT DURCHGEFHRT WORDEN !            
ECHO Ĵ
ECHO Weiter mit Tastendruck ...                                      
ECHO 
ECHO 
PAUSE > NUL
GOTO ENDE

:ENDE




