// ---------------------------------------------------------------------------
// Name, Vorname, Datum, Quelle
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_001()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdlPrn := 0
LOCAL sFile   := "EXPORT\GPEXP_P.DBF"
LOCAL sFileIdx:= "EXPORT\GPEXP_P.NTX"

LOCAL fOk     := .F.
LOCAL iRec
LOCAL sZeile  := ""

LOCAL iPrnBreite
LOCAL i,j

LOCAL iNamenLen, sName

// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Quelle - Personen (Taufeintrge)"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Datenstze"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Analyse"
   @ 14,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE(sFile)
      fehler("Datei '" + sFile + "' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   USE (sFile) ALIAS PERSONEN NEW EXCLUSIVE
   IF NETERR()
      fehler("Datei '" + sFile + "' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   iNamenLen := LEN(PERSONEN->NAME)   + ;
                LEN(PERSONEN->VNAMEN) + 3

   INDEX ON PADR(UPPER(IF("," $ PERSONEN->NAME, SUBS(PERSONEN->NAME, 1, AT(",", PERSONEN->NAME)-1), PERSONEN->NAME)), iNamenLen) + ;
            UPPER(PERSONEN->VNAMEN) + ;
            PERSONEN->S002_D_V ;
            TO (sFileIdx)

   // ------------------------------------------------------------------------
   // Umfang anzeigen ...
   // ------------------------------------------------------------------------
   @ 7,30 SAY STR(PERSONEN->(LASTREC()), 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_001.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // Maximale Druckbreite =
   // Namenlnge + Trennzeichen + Ortslnge + Trennzeichen + von-bis
   iPrnBreite := LEN(PERSONEN->NAME)   + ;
                 LEN(PERSONEN->VNAMEN) + ;
                 30

   IF iPrnBreite < 92 ; iPrnBreite := 92 ; ENDIF

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT PERSONEN
   GO TOP

   iRec := 1

   IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=" + ISTR(iNamenLen + 12)) ; BREAK ; ENDIF

   DO WHILE ! PERSONEN->(EOF())

      // ---------------------------------------------------------------------
      // Nur Eintrge mit Datum und Quellenangabe
      // ---------------------------------------------------------------------
      IF ! EMPTY(PERSONEN->S002_D_V) .AND. ;
         ! EMPTY(PERSONEN->S002_Q_Q)

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         IF EMPTY(PERSONEN->NAME)
            sName := "n.n."
         ELSE
            sName := ALLTRIM(PERSONEN->NAME)
         ENDIF

         IF EMPTY(PERSONEN->VNAMEN)
            sName += ", (" +  LOWER(PERSONEN->SEX) + ")"
         ELSE
            sName += ", " + ALLTRIM(PERSONEN->VNAMEN)
         ENDIF

         sZeile := PADR(sName, iNamenLen) + "^#"

         sZeile += SUBS(PERSONEN->S002_D_V,7,2) + "." +;
                   SUBS(PERSONEN->S002_D_V,5,2) + "." +;
                   SUBS(PERSONEN->S002_D_V,1,4) + "  ^#"

         // Quelleninformationen
         sZeile += ALLTRIM(PERSONEN->S002_Q_Q)

         IF ! EMPTY(PERSONEN->S002_Q_SEI)
            sZeile += " " + ALLTRIM(PERSONEN->S002_Q_SEI)
            IF ! EMPTY(PERSONEN->S002_Q_POS)
               sZeile += "/" + ALLTRIM(PERSONEN->S002_Q_POS)
            ENDIF
         ENDIF

         IF ! EMPTY(PERSONEN->S002_Q_RNR)
            sZeile += " " + ALLTRIM(PERSONEN->S002_Q_RNR)
         ENDIF

         IF ! FWRITELINE(iHdlPrn, sZeile)
            BREAK
         ENDIF
      ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 14,30 SAY STR(iRec/PERSONEN->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 14,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Quelle-Personenbersicht^(Taufe)"  + CRLF + ;
           "Z=" + ISTR(iPrnBreite+2)                   + CRLF,  ;    // zus.  Luft
           "AW_001.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFileIdx)                    // Hilfsdatei wird nicht mehr bentigt
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_001.DEF")
      FERASE("AW_001.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
