// ---------------------------------------------------------------------------
// Alter - Personenbersicht
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_ap()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_APER.DBF"
LOCAL sFileDbt:= "AW_APER.DBT"
LOCAL sFileIdx:= "AW_APER.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer, sPerSort
LOCAL sAlter

LOCAL fGPFok
LOCAL iRec

LOCAL i

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Alter-Personen (Kompakt)", "Alter-Personen (bersicht)"})

   IF i = 1
      @ 4,0  SAY "Alter - Personen in der Kompaktausgabe"
      sListTyp := "KOMP"
   ELSEIF i = 2
      @ 4,0  SAY "Alter - Personen in der bersichtausgabe"
      sListTyp := "UEB"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_APER.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"ALTER"      ,"C",   2, 0})
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_APER EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON AW_APER->ALTER + UPPER(AW_APER->PERSORT) TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sPerSort := ""
   sAlter   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF ! EMPTY(sAlter)   .AND. ;
            ! EMPTY(sPer)     .AND. ;
            ! EMPTY(sPerSort)

            SELECT AW_APER
            APPEND BLANK
            AW_APER->ALTER    := getAlterTyp(sAlter)
            AW_APER->PERSORT  := sPerSort
            AW_APER->PERSON   := sPer
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         sAlter := ""

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.SORT"
               sPerSort := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP"
               IF sListTyp == "KOMP"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB"
               IF sListTyp == "UEB"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.ALT_JMT"
               sAlter := ALLTRIM(sZeile)

               IF sAlter == "?"
                  sAlter := ""
               ENDIF

               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_APER->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_APER
   GO TOP

   iRec := 1

   DO WHILE ! AW_APER->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      IF ! FWRITELINE(iHdlPrn, "#R")      // Absatzformatierungen zurcksetzen
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#L2") ; BREAK ; ENDIF

      sAlter := getAlterTyp(AW_APER->ALTER)

      DO CASE
      CASE sAlter == "01"
         IF ! FWRITELINE(iHdlPrn, "^Abis 1 Jahr^B") ; BREAK ; ENDIF
      CASE sAlter == "05"
         IF ! FWRITELINE(iHdlPrn, "^Abis 5 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "10"
         IF ! FWRITELINE(iHdlPrn, "^Abis 10 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "20"
         IF ! FWRITELINE(iHdlPrn, "^Abis 20 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "30"
         IF ! FWRITELINE(iHdlPrn, "^Abis 30 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "40"
         IF ! FWRITELINE(iHdlPrn, "^Abis 40 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "50"
         IF ! FWRITELINE(iHdlPrn, "^Abis 50 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "60"
         IF ! FWRITELINE(iHdlPrn, "^Abis 60 Jahre^B") ; BREAK ; ENDIF
      CASE sAlter == "70"
         IF ! FWRITELINE(iHdlPrn, "^Abis 70 Jahre^B") ; BREAK ; ENDIF
      OTHERWISE
         IF ! FWRITELINE(iHdlPrn, "^Alter als 70 Jahre^B") ; BREAK ; ENDIF
      ENDCASE

      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=4")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF

      DO WHILE ! AW_APER->(EOF()) .AND. ;
               sAlter == getAlterTyp(AW_APER->ALTER)

         // "^#" ist z.B. fr den WP Druck wichtig.  Dann wird
         // eine Einrckung gesendet, so da eine optimale Formatierung
         // mglich ist
         IF ! FWRITELINE(iHdlPrn, "^#" + AW_APER->PERSON)
            BREAK
         ENDIF

         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 13,30 SAY STR(iRec/AW_APER->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Alter^-^Personenbersicht"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_APER.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_APER.DEF")
      FERASE("AW_APER.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
static FUNCTION getAlterTyp(sAlter)
// ---------------------------------------------------------------------------
LOCAL iAlter := VAL(SUBS(sAlter,1,3))
LOCAL sRet   := "99"

   DO CASE
   CASE iAlter <= 1
      sRet := "01"
   CASE iAlter <= 5
      sRet := "05"
   CASE iAlter <= 10
      sRet := "10"
   CASE iAlter <= 20
      sRet := "20"
   CASE iAlter <= 30
      sRet := "30"
   CASE iAlter <= 40
      sRet := "40"
   CASE iAlter <= 50
      sRet := "50"
   CASE iAlter <= 60
      sRet := "60"
   CASE iAlter <= 70
      sRet := "70"
   ENDCASE

RETURN(sRet)
// ---------------------------------------------------------------------------
