// ---------------------------------------------------------------------------
// Begrbnisregister, Originalreihenfolge
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_brego()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_BREG.DBF"
LOCAL sFileDbt:= "AW_BREG.DBT"
LOCAL sFileIdx:= "AW_BREG.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer
LOCAL sSach
LOCAL sQuelle, sSeite, sPos, sReg, sQText

LOCAL sQtyp

LOCAL fGPFok
LOCAL iRec

LOCAL i, iMax1, iMax2, iLen, sLRand
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Begrbnisregister in Originalreihenfolge"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Analyse"
   @ 14,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_BREG.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"QUELLE"    ,"C", 60, 0})
   AADD(aDbf, {"SEITE",     "C",  5, 0})
   AADD(aDbf, {"SEITE_POS", "C",  4, 0})
   AADD(aDbf, {"REG_NR",    "C", 20, 0})
   AADD(aDbf, {"QTEXT"     ,"M", 10, 0})
   AADD(aDbf, {"SACH"      ,"M", 10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_BREG EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(AW_BREG->QUELLE + AW_BREG->SEITE + AW_BREG->SEITE_POS + AW_BREG->REG_NR) TO (sFileIdx)

   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sSach    := ""
   sQuelle  := ""
   sSeite   := ""
   sPos     := ""
   sReg     := ""
   sQText   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF ! EMPTY(sQuelle)
            SELECT AW_BREG
            APPEND BLANK

            AW_BREG->QUELLE     := sQuelle
            AW_BREG->SEITE      := STR(VAL(sSeite), 5)
            AW_BREG->SEITE_POS  := STR(VAL(sPos), 4)
            AW_BREG->REG_NR     := sReg
            AW_BREG->QTEXT      := sQText
            AW_BREG->SACH       := sPer + IF(! EMPTY(sPer), " ", "") + sSach
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         sPer     := ""
         sSach    := ""
         sQuelle  := ""
         sSeite   := ""
         sPos     := ""
         sReg     := ""
         sQText   := ""

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.DAR.NAME"
               sPer := sZeile
               fGPFok   := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.SACH.#004"

               sQuelle  := ""
               sSeite   := ""
               sPos     := ""
               sReg     := ""
               sQText   := ""
               sSach   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAR.SACH"
                     sSach := sZeile
                  ELSEIF sTag == "GP.Q.QUELLE"
                     sQuelle := sZeile
                  ELSEIF sTag == "GP.Q.SEITE"
                     sSeite := sZeile
                  ELSEIF sTag == "GP.Q.POS"
                     sPos := sZeile
                  ELSEIF sTag == "GP.Q.REG"
                     sReg := sZeile

                  // Achtung : Nachfolgende Zusammenstellung funktioniert
                  // nur, auf Grund der bekannten Datenzusammenstellung!
                  // Normalerweise htte hier eine weitere Schachtelung
                  // erfolgen mssen!
                  ELSEIF sTag == "GP.Q.ORIG"
                     sQText += IF(! EMPTY(sQText), CRLF, "") + sZeile
                  ELSEIF sTag == "GP.Q.KOMM"
                     sQText += IF(! EMPTY(sQText), CRLF, "") + sZeile
                  ELSEIF sTag == "CONT"
                     sQText += IF(! EMPTY(sQText), CRLF, "") + sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_BREG->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Linken Rand ermitteln ...
   // ---------------------------------------------------------------------------
   iMax1 := 0
   iMax2 := 0

   SELECT AW_BREG
   GO TOP

   iRec := 1

   DO WHILE ! AW_BREG->(EOF())

      iLen := LEN(ALLTRIM(AW_BREG->SEITE) + ALLTRIM(AW_BREG->SEITE_POS))
      IF iLen > iMax1
         iMax1 := iLen
      ENDIF

      iLen := LEN(ALLTRIM(AW_BREG->REG_NR))
      IF iLen > iMax2
         iMax2 := iLen
      ENDIF

      IF INKEY() == 27 ; BREAK ; ENDIF
      iRec ++
      SKIP
      @ 13,30 SAY STR(iRec/AW_BREG->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_BREG
   GO TOP

   iLen := 0
   IF iMax1 > 0 ; iLen += iMax1 + 2 ; ENDIF
   IF iMax2 > 0 ; iLen += iMax2 + 1 ; ENDIF
   IF iLen > 0
      sLRand := ISTR(iLen)
   ELSE
      sLRand := "2"
   ENDIF

   iRec := 1

   DO WHILE ! AW_BREG->(EOF())

      sQTyp := UPPER(AW_BREG->QUELLE)
      IF ! FWRITELINE(iHdlPrn, "#R")                ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#L3")               ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "^A" + ALLTRIM(AW_BREG->QUELLE) + "^B") ; BREAK ; ENDIF

      DO WHILE ! AW_BREG->(EOF()) .AND. ;
               sQTyp == UPPER(AW_BREG->QUELLE)

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         IF ! FWRITELINE(iHdlPrn, "#ABS_LR=0")           ; BREAK ; ENDIF
         IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=" + sLRand) ; BREAK ; ENDIF

         sZeile := ""
         IF iMax1 > 0
            sZeile += PADR(ALLTRIM(AW_BREG->SEITE) + "/" + ;
                           ALLTRIM(AW_BREG->SEITE_POS), iMax1+1) + " ^#"
         ENDIF
         IF iMax2 > 0
            sZeile += PADR(ALLTRIM(AW_BREG->REG_NR), iMax2) + " ^#"
         ENDIF
         sZeile += AW_BREG->SACH
         IF ! FWRITELINE(iHdlPrn, sZeile) ; BREAK ; ENDIF

         IF ! EMPTY(AW_BREG->QTEXT)
            IF ! FWRITELINE(iHdlPrn, "#ABS_LR=" + sLRand) ; BREAK ; ENDIF
            IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=0")       ; BREAK ; ENDIF
            IF ! FWRITELINE(iHdlPrn, "#ABS_RED=J")        ; BREAK ; ENDIF
            IF ! FWRITELINE(iHdlPrn, AW_BREG->QTEXT)      ; BREAK ; ENDIF
            IF ! FWRITELINE(iHdlPrn, "#ABS_RED=N")        ; BREAK ; ENDIF
            IF ! FWRITELINE(iHdlPrn, "")                  ; BREAK ; ENDIF
         ENDIF

         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 14,30 SAY STR(iRec/AW_BREG->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 14,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Begrbnisregister^in^Originalreihenfolge"   + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_BREG.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_BREG.DEF")
      FERASE("AW_BREG.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------



