// ---------------------------------------------------------------------------
// Quellen - Personenbersicht
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_find()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_FIND.DBF"
LOCAL sFileDbt:= "AW_FIND.DBT"
LOCAL sFileIdx:= "AW_FIND.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer, sPerSort
LOCAL sQuelle, sRegNr, sSeite, sPos

LOCAL fGPFok
LOCAL iRec

LOCAL aQuelle  := {}
LOCAL i

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Kompakt", "bersicht"})

   IF i = 1
      @ 4,0  SAY "Findbuch in der Kompaktausgabe"
      sListTyp := "KOMP"
   ELSEIF i = 2
      @ 4,0  SAY "Findbuch in der bersichtausgabe"
      sListTyp := "UEB"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPFIN.GDF")
      fehler("Datei 'EXPORT\GPFIN.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPFIN.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPFIN.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_FIND.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"QUELLE"     ,"M",  10, 0})

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_FIND EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON AW_FIND->PERSORT TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sPerSort := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF LEN(aQuelle)  > 0   .AND. ;
            ! EMPTY(sPer)       .AND. ;
            ! EMPTY(sPerSort)

            APPEND BLANK
            AW_FIND->PERSORT  := sPerSort
            AW_FIND->PERSON   := sPer
            AW_FIND->QUELLE   := sortQuelle(aQuelle)
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         aQuelle  := {}

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.SORT"
               sPerSort := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP"
               IF sListTyp == "KOMP"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB"
               IF sListTyp == "UEB"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.Q"

               // Alle Eintrge zur Quelle abarbeiten ...
               sQuelle  := ""
               sRegNr   := ""
               sSeite   := ""
               sPos     := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.Q.QUELLE"
                     sQuelle := sZeile
                  ELSEIF sTag == "GP.Q.SEITE"
                     sSeite := sZeile
                  ELSEIF sTag == "GP.Q.POS"
                     sPos := sZeile
                  ELSEIF sTag == "GP.Q.REG"
                     sRegNr := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sQuelle)

                  sQuelle := ALLTRIM(sQuelle)

                  IF ! EMPTY(sSeite)
                     sSeite := "S" + ALLTRIM(sSeite)
                     IF ! EMPTY(sPos)
                        sSeite += "/" + ALLTRIM(sPos)
                     ENDIF
                  ENDIF

                  IF ! EMPTY(sRegNr)
                     sRegNr := ALLTRIM(sRegNr)

                     IF ! EMPTY(sSeite)
                        sRegNr += " " + sSeite
                     ENDIF
                  ELSE
                     sRegNr := sSeite
                  ENDIF

                  IF ! EMPTY(sRegNr)
                     sQuelle += " ^#" + sRegNr
                  ENDIF

                  AADD(aQuelle, sQuelle)
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_FIND->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_FIND
   GO TOP

   iRec := 1

   DO WHILE ! AW_FIND->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=0")     ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2")   ; BREAK ; ENDIF

      IF ! FWRITELINE(iHdlPrn, AW_FIND->PERSON) ; BREAK ; ENDIF

      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=2")     ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, AW_FIND->QUELLE) ; BREAK ; ENDIF

      IF ! FWRITELINE(iHdlPrn, "")              ; BREAK ; ENDIF
      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 13,30 SAY STR(iRec/AW_FIND->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Findbuch"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_FIND.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_FIND.DEF")
      FERASE("AW_FIND.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
static FUNCTION sortQuelle(aQuelle)
// ---------------------------------------------------------------------------

LOCAL sRet := ""
LOCAL iNum, i, j
LOCAL sQuelle
LOCAL aQNeu   := {}

LOCAL fAdd

   FOR i := 1 TO LEN(aQuelle)
      sQuelle := ALLTRIM(aQuelle[i])

      IF ! EMPTY(sQuelle)

         fAdd  := .T.

         FOR j := 1 TO LEN(aQNeu)

            IF UPPER(aQNeu[j]) == UPPER(sQuelle)
               fAdd  := .F.
               EXIT
            ENDIF
         NEXT

         IF fAdd
            AADD(aQNeu, sQuelle)
         ENDIF
      ENDIF
   NEXT

   ASORT(aQNeu)

   FOR i := 1 TO LEN(aQNeu)
      IF EMPTY(sRet)
         sRet := aQNeu[i]
      ELSE
         sRet += CRLF + aQNeu[i]
      ENDIF
   NEXT

RETURN(sRet)
// ---------------------------------------------------------------------------
