// ---------------------------------------------------------------------------
// Forschungsstandanalyse
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_fstan()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_FSTAN.DBF"
LOCAL sFileDbt:= "AW_FSTAN.DBT"
LOCAL sFileIdx:= "AW_FSTAN.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sOrt, sDatum

LOCAL fGPFok
LOCAL iRec

LOCAL iPrnLen := 1
LOCAL i, iLen
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Forschungsstand"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_FSTAN.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"NR"         ,"C",   6, 0})
   AADD(aDbf, {"SEX"        ,"C",   1, 0})
   AADD(aDbf, {"KONF"       ,"C",   2, 0})
   AADD(aDbf, {"IS_NAME"    ,"L",   1, 0})
   AADD(aDbf, {"IS_VNAME"   ,"L",   1, 0})
   AADD(aDbf, {"IS_GEB_D"   ,"L",   1, 0})
   AADD(aDbf, {"IS_GEB_O"   ,"L",   1, 0})
   AADD(aDbf, {"IS_TAU_D"   ,"L",   1, 0})
   AADD(aDbf, {"IS_TAU_O"   ,"L",   1, 0})
   AADD(aDbf, {"IS_STB_D"   ,"L",   1, 0})
   AADD(aDbf, {"IS_STB_O"   ,"L",   1, 0})
   AADD(aDbf, {"IS_BEG_D"   ,"L",   1, 0})
   AADD(aDbf, {"IS_BEG_O"   ,"L",   1, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_FSTAN EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON AW_FSTAN->PERSORT TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++

            SELECT AW_FSTAN
            APPEND BLANK

            AW_FSTAN->NR       := sZeile
            AW_FSTAN->IS_NAME  := .F.
            AW_FSTAN->IS_VNAME := .F.
            AW_FSTAN->IS_GEB_D := .F.
            AW_FSTAN->IS_GEB_O := .F.
            AW_FSTAN->IS_TAU_D := .F.
            AW_FSTAN->IS_TAU_O := .F.
            AW_FSTAN->IS_STB_D := .F.
            AW_FSTAN->IS_STB_O := .F.
            AW_FSTAN->IS_BEG_D := .F.
            AW_FSTAN->IS_BEG_O := .F.

         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.SORT"
               AW_FSTAN->PERSORT := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP"
               AW_FSTAN->PERSON := sZeile

               iLen := LEN(sZeile)               // Ausgabebreite ermitteln
               IF iLen  > iPrnLen
                  iPrnLen := iLen
               ENDIF

               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "RELI"
               AW_FSTAN->KONF := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.NAME"
               AW_FSTAN->IS_NAME :=  ! EMPTY(sZeile)
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.VNAMEN"
               AW_FSTAN->IS_VNAME :=  ! EMPTY(sZeile)
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "SEX"
               AW_FSTAN->SEX := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.SACH.#001"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               AW_FSTAN->IS_GEB_D := ! EMPTY(sDatum)
               AW_FSTAN->IS_GEB_O := ! EMPTY(sOrt)
            ELSEIF sTag == "GP.SACH.#002"

               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               AW_FSTAN->IS_TAU_D := ! EMPTY(sDatum)
               AW_FSTAN->IS_TAU_O := ! EMPTY(sOrt)
            ELSEIF sTag == "GP.SACH.#003"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               AW_FSTAN->IS_STB_D := ! EMPTY(sDatum)
               AW_FSTAN->IS_STB_O := ! EMPTY(sOrt)
            ELSEIF sTag == "GP.SACH.#004"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               AW_FSTAN->IS_BEG_D := ! EMPTY(sDatum)
               AW_FSTAN->IS_BEG_O := ! EMPTY(sOrt)
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_FSTAN
   GO TOP

   iRec := 1

   IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF

   DO WHILE ! AW_FSTAN->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      sZeile := PADR(AW_FSTAN->PERSON, iPrnLen, ".")  + "  ^#" + ;
                      IF(AW_FSTAN->IS_NAME,"n", " ")  + IF(AW_FSTAN->IS_VNAME,"v", " ") + " ^#" + ;
                "*" + IF(AW_FSTAN->IS_GEB_D,"d", " ") + IF(AW_FSTAN->IS_GEB_O,"o", " ") + " ^#" + ;
                "~" + IF(AW_FSTAN->IS_TAU_D,"d", " ") + IF(AW_FSTAN->IS_TAU_O,"o", " ") + " ^#" + ;
                "+" + IF(AW_FSTAN->IS_STB_D,"d", " ") + IF(AW_FSTAN->IS_STB_O,"o", " ") + " ^#" + ;
                "" + IF(AW_FSTAN->IS_BEG_D,"d", " ") + IF(AW_FSTAN->IS_BEG_O,"o", " ")

      IF ! FWRITELINE(iHdlPrn, sZeile) ; BREAK ; ENDIF
      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 13,30 SAY STR(iRec/AW_FSTAN->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   iPrnLen += 22
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Forschungsstand^:^Personen"  + CRLF + ;
           "Z=" + ISTR(iPrnLen)     + CRLF,  ;    // zus.  Luft
           "AW_FSTAN.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_FSTAN.DEF")
      FERASE("AW_FSTAN.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
