// ---------------------------------------------------------------------------
// Einfacher GEDCOM Export
//
// Es werden nur die  Namen und die elementaren Daten *,~,+,+/- und die Orte
// bertragen. Dieser Export dient nur als Beipsiel fr eigene Erweiterungen!
//
// Der hier enthaltene Programmablauf ist besonders einfach gehalten. Mit
// wenig Aufwand kann der Umfang halbiert werden - worunter die
// bersichtlichkeit gelitten htte.
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_ged()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlGed := 0
LOCAL aDbf    := {}
LOCAL sFile   := "EXPORT.GED"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0
LOCAL iFam    := 0

LOCAL fPer, fFam, cLevel, cAltLevel, sTag
LOCAL sName
LOCAL sOrt, sDatum

LOCAL fGPFok
LOCAL iRec

LOCAL i,j

// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"
   @ 11,0 SAY "Anzahl Familien"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // GEDCOM Datei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlGed := FCREATE(sFile)

   IF iHdlGed < 1
      fehler("GEDCOM Datei '" + sFile + "' konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Kopfdaten schreiben
   // ------------------------------------------------------------------------
   WGEDLINE(iHdlGed, "0 HEAD")
   WGEDLINE(iHdlGed, "1 SOUR GP_96_STD")
   WGEDLINE(iHdlGed, "1 DEST PAF 2.1")
   WGEDLINE(iHdlGed, "1 DATE " + GED_DATE(DTOS(DATE())))
   WGEDLINE(iHdlGed, "1 FILE " + sFile)
   WGEDLINE(iHdlGed, "1 CHAR IBMPC")

   // ------------------------------------------------------------------------
   // Einlesen und schreiben der Daten ...
   // ------------------------------------------------------------------------
   fPer   := .F.
   fFam   := .F.
   sTag   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         IF sTag == "TRLR"             // Dateiende
            WGEDLINE(iHdlGed, "0 TRLR")
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T. ; fFam := .F.
            iPer++
            WGEDLINE(iHdlGed, "0 @" + sZeile + "@ INDI")
         ELSEIF sTag == "FAM"          // Familien
            fFam := .T. ; fPer := .F.
            iFam++
            WGEDLINE(iHdlGed, "0 @" + sZeile + "@ FAM")
         ELSE                          // Ignorieren
            fPer := .F.
            fFam := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // Personen analysieren
            IF sTag == "NAME"
               WGEDLINE(iHdlGed, "1 NAME " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "RELI"
               WGEDLINE(iHdlGed, "1 RELI " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "SEX"
               WGEDLINE(iHdlGed, "1 SEX " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "FAMS"
               WGEDLINE(iHdlGed, "1 FAMS " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "FAMC"
               WGEDLINE(iHdlGed, "1 FAMC " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.SACH.#001"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sDatum) .OR. ;
                  ! EMPTY(sOrt)

                  WGEDLINE(iHdlGed, "1 BIRT")
                  IF ! EMPTY(sDatum)
                     WGEDLINE(iHdlGed, "2 DATE " + GED_DATE(sDatum))
                  ENDIF
                  IF ! EMPTY(sOrt)
                     WGEDLINE(iHdlGed, "2 PLAC " + sOrt)
                  ENDIF
               ENDIF
            ELSEIF sTag == "GP.SACH.#002"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sDatum) .OR. ;
                  ! EMPTY(sOrt)

                  WGEDLINE(iHdlGed, "1 CHR")
                  IF ! EMPTY(sDatum)
                     WGEDLINE(iHdlGed, "2 DATE " + GED_DATE(sDatum))
                  ENDIF
                  IF ! EMPTY(sOrt)
                     WGEDLINE(iHdlGed, "2 PLAC " + sOrt)
                  ENDIF
               ENDIF
            ELSEIF sTag == "GP.SACH.#003"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sDatum) .OR. ;
                  ! EMPTY(sOrt)

                  WGEDLINE(iHdlGed, "1 DEAT")
                  IF ! EMPTY(sDatum)
                     WGEDLINE(iHdlGed, "2 DATE " + GED_DATE(sDatum))
                  ENDIF
                  IF ! EMPTY(sOrt)
                     WGEDLINE(iHdlGed, "2 PLAC " + sOrt)
                  ENDIF
               ENDIF
            ELSEIF sTag == "GP.SACH.#004"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sDatum) .OR. ;
                  ! EMPTY(sOrt)

                  WGEDLINE(iHdlGed, "1 BURI")
                  IF ! EMPTY(sDatum)
                     WGEDLINE(iHdlGed, "2 DATE " + GED_DATE(sDatum))
                  ENDIF
                  IF ! EMPTY(sOrt)
                     WGEDLINE(iHdlGed, "2 PLAC " + sOrt)
                  ENDIF
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSEIF fFam                    // Familien analysieren
            IF SUBS(sTag,1,8) == "GP.MANN."
               WGEDLINE(iHdlGed, "1 HUSB " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF SUBS(sTag,1,8) == "GP.FRAU."
               WGEDLINE(iHdlGed, "1 WIFE " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF SUBS(sTag,1,8) == "GP.KIND."
               WGEDLINE(iHdlGed, "1 CHIL " + sZeile)
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.SACH.#103"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sDatum := ""
               sOrt   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sDatum) .OR. ;
                  ! EMPTY(sOrt)

                  WGEDLINE(iHdlGed, "1 MARR")
                  IF ! EMPTY(sDatum)
                     WGEDLINE(iHdlGed, "2 DATE " + GED_DATE(sDatum))
                  ENDIF
                  IF ! EMPTY(sOrt)
                     WGEDLINE(iHdlGed, "2 PLAC " + sOrt)
                  ENDIF
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 11,30 SAY STR(iFam, 15, 0)
      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FCLOSE(iHdl)
   FCLOSE(iHdlGed)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("EXPORT.GED")
   ENDIF

RETURN
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
PROCEDURE WGEDLINE(iHdlGed, _s)

   IF ! FWRITELINE(iHdlGed, _s)
      BREAK
   ENDIF

RETURN
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
FUNCTION GED_MONTH(i)
RETURN(" " + SUBS("JAN/FEB/MAR/APR/MAY/JUN/JUL/AUG/SEP/OCT/NOV/DEC", (i-1)*4+1,3) + " ")
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
FUNCTION GED_DATE(_s)
// ---------------------------------------------------------------------------
LOCAL iT, iM, iJ
LOCAL sRet := ""
// ---------------------------------------------------------------------------
// In GENprofi kann der Monat unbekannt sein, dies ist in GEDCOM nicht
// definiert bzw. wird nicht untersttzt.
// ---------------------------------------------------------------------------
   iT := VAL(SUBS(_s,7,2))
   iM := VAL(SUBS(_s,5,2))
   iJ := VAL(SUBS(_s,1,4))

   IF iJ > 0
      IF iM > 0
         IF iT > 0
            sRet := ISTR(iT) + GED_MONTH(iM) + ISTR(iJ)
         ELSE
            sRet := GED_MONTH(iM) + ISTR(iJ)
         ENDIF
      ELSE
         sRet := ISTR(iJ)
      ENDIF
   ENDIF

RETURN(sRet)
// ---------------------------------------------------------------------------



