// ---------------------------------------------------------------------------
// Namenauswertung
//
// Dieses Programm liest die Exportdatei GPNAM.GDF ein und ermittelt die
// Hufigkeit, wie oft ein Name vorkommt.
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_namen()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_NAMEN.DBF"
LOCAL sFileIdx:= "AW_NAMEN.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sName, sNamTyp

LOCAL fGPFok
LOCAL iRec

LOCAL fZeilenweise, cAnfang, iNamZahl
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Namensauswertung"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Namen"
   @ 13,0 SAY "Stand der Ausgabe"

   fZeilenweise := frage("Namen zeilenweise ausgeben?")

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPNAM.GDF")
      fehler("Datei 'EXPORT\GPNAM.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPNAM.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPNAM.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_NAMEN.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"NAME"   ,"C", 60, 0})
   AADD(aDbf, {"ZNAM"   ,"N", 10, 0})
   AADD(aDbf, {"ZANG"   ,"N", 10, 0})
   AADD(aDbf, {"ZSON"   ,"N", 10, 0})

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_NAMEN EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(AW_NAMEN->NAME) TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer   := .F.
   sTag   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.NAME"
               IF "," $ sZeile         // Namenszustze und Adelstitel ignorieren
                  sZeile := PADR(SUBS(sZeile, 1, AT(",", sZeile)-1), 60)
               ELSE
                  sZeile := PADR(sZeile, 60)
               ENDIF

               IF ! EMPTY(sZeile)
                  sName := sZeile

                  // Wenn kein Namentyp angegeben wurde, automatisch
                  // auf Geburtsnamen setzen
                  sNamTyp := "#0"

                  // Alle Eintrge zum Namen abarbeiten ...
                  cAltLevel := cLevel
                  fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

                  DO WHILE cAltLevel < cLevel .AND. fGPFok
                     IF sTag == "GP.NAME.TYP"
                        sNamTyp := sZeile
                     ENDIF
                     fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
                  ENDDO

                  // Bestimmte Namentypen werden unterdrckt, da die
                  // Aufnahme in diese Auswertung sinnlos wre

                  IF sNamTyp != "#1" .AND. ;    // Stamname
                     sNamTyp != "#H" .AND. ;    // Stamm : a.d.H.
                     sNamTyp != "#2" .AND. ;    // vorangest. Adelstitel
                     sNamTyp != "#B" .AND. ;    // Beiname
                     ! EMPTY(sName)             // na ja, und ein Name mu schon da sein

                     SELECT AW_NAMEN
                     SEEK UPPER(sName)

                     IF ! FOUND()
                        APPEND BLANK
                        AW_NAMEN->NAME := sName
                     ENDIF

                     IF sNamTyp == "#0" .OR. ;  // Geburtsname
                        sNamTyp == "#3" .OR. ;  // weitere Namen
                        sNamTyp == "#4" .OR. ;  // weitere Namen, Form 2
                        sNamTyp == "#P" .OR. ;  // Patronym
                        sNamTyp == "#G" .OR. ;  // genannt
                        sNamTyp == "#S"         // Schreibweise

                        AW_NAMEN->ZNAM := AW_NAMEN->ZNAM + 1
                     ELSEIF sNamTyp == "#A" .OR. ;    // Adoption
                            sNamTyp == "#N" .OR. ;    // Namennderung
                            sNamTyp == "#V"           // Name durch Heirat angenommen
                        AW_NAMEN->ZANG := AW_NAMEN->ZANG + 1
                     ELSE                             // der ganze Rest
                        AW_NAMEN->ZSON := AW_NAMEN->ZSON + 1
                     ENDIF
                  ENDIF
               ENDIF
            ELSE                       // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_NAMEN->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_NAMEN
   GO TOP

   iRec := 1

   // ---------------------------------------------------------------------------
   // Vortext
   // ---------------------------------------------------------------------------
   sZeile := "Es werden alle Namen aufgefhrt, die in der Forschung " +;
             "verwendet werden. Die erste Zahl gibt an, wie oft ein Name " +;
             "als Geburtsname (gilt auch fr Schreibweisen, Patronym oder 'genannt') " +;
             "auftritt. Die zweite Zahl gibt an, wie oft ein Name z.B. durch " +;
             "Eheschlieung oder Adoption angenommen wurde. Die dritte Angabe " +;
             "fhrt schlielich auf, wie oft der Name in einem anderen Kontext " +;
             "Verwendung fand." + CRLF + ;
             "Beinamen (z.B. 'der ltere') und Stammnamen sowie die Namenzustze " + ;
             "(z.B. von, van, van der, etc.) werden in dieser " +;
             "Auswertung nicht bercksichtigt." + CRLF + ;
             "^AFett^B gedruckte Namen treten mindestens zehnmal als Geburtsname " + ;
             "in dieser Forschung auf und werden aus diesem Grund hervorgehoben." + ;
             CRLF + ;
             "#ZG" + CRLF

   IF ! FWRITELINE(iHdlPrn, sZeile)
      BREAK
   ENDIF

   // ---------------------------------------------------------------------------
   // Alle Namen
   // ---------------------------------------------------------------------------
   IF fZeilenweise
      DO WHILE ! AW_NAMEN->(EOF())

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         sZeile := ALLTRIM(AW_NAMEN->NAME)

         IF AW_NAMEN->ZNAM > 9            // dann den Namen <fett> drucken
            sZeile := "^A" + sZeile + "^B"
         ENDIF

         sZeile += " (" + ISTR(AW_NAMEN->ZNAM)

         IF AW_NAMEN->ZSON > 0
            sZeile += "/" + ISTR(AW_NAMEN->ZANG) + ;
                      "/" + ISTR(AW_NAMEN->ZSON)

         ELSEIF AW_NAMEN->ZANG > 0
            sZeile += "/" + ISTR(AW_NAMEN->ZANG)
         ENDIF

         sZeile += ")"

         IF ! FWRITELINE(iHdlPrn, sZeile)
            BREAK
         ENDIF

         // ------------------------------------------------------------------------
         // Mit ESC kann der ganze Zauber abgebrochen werden
         // ------------------------------------------------------------------------
         IF INKEY() == 27 ; BREAK ; ENDIF

         iRec ++
         SKIP

         @ 13,30 SAY STR(iRec/AW_NAMEN->(LASTREC()) * 100, 14) + "%"
      ENDDO
      @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung
   ELSE
      IF ! FWRITELINE(iHdlPrn, "#R")      // Absatzformatierungen zurcksetzen
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2")   // Folgezeilen im Absatzdruck 3 Zeichen einrcken
         BREAK
      ENDIF

      DO WHILE ! AW_NAMEN->(EOF())

         cAnfang  := UPPER(SUBS(ALLTRIM(AW_NAMEN->NAME), 1, 1))
         iNamZahl := 0

         DO WHILE ! AW_NAMEN->(EOF()) .AND. ;
                  cAnfang == UPPER(SUBS(ALLTRIM(AW_NAMEN->NAME), 1, 1))

            // "#SATZNR" gibt die lfd. Nummer an.
            // Auf diese Angabe knnte verzichtet werden, aber so ist die
            // Ausgabe vollstndig.
            IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

            sZeile   := ALLTRIM(AW_NAMEN->NAME)

            IF AW_NAMEN->ZNAM > 9            // dann den Namen <fett> drucken
               sZeile := "^A" + sZeile + "^B"
            ENDIF

            // Bei der Umbruchausgabe wird statt "()" in "<>" eingeklammert,
            // Die interne Umbruchfunktion bewirkt u.U. bei einer "("
            // einen Zeilenumbruch und dann knnte eine Folgezeile mit
            // einer "(" beginnen. Das sieht aber nicht so toll aus.

            sZeile += GESCH_LEER + "<" + ISTR(AW_NAMEN->ZNAM)

            IF AW_NAMEN->ZSON > 0
               sZeile += "/" + ISTR(AW_NAMEN->ZANG) + ;
                         "/" + ISTR(AW_NAMEN->ZSON)

            ELSEIF AW_NAMEN->ZANG > 0
               sZeile += "/" + ISTR(AW_NAMEN->ZANG)
            ENDIF

            sZeile += ">"

            IF iNamZahl > 0
               IF ! FWRITESTR(iHdlPrn, ", " + sZeile)
                  BREAK
               ENDIF
            ELSE
               IF ! FWRITESTR(iHdlPrn, sZeile)
                  BREAK
               ENDIF
            ENDIF

            // ------------------------------------------------------------------------
            // Mit ESC kann der ganze Zauber abgebrochen werden
            // ------------------------------------------------------------------------
            IF INKEY() == 27 ; BREAK ; ENDIF

            iNamZahl++
            iRec ++
            SKIP
         ENDDO
         IF ! FWRITESTR(iHdlPrn, CRLF)
            BREAK
         ENDIF


         @ 13,30 SAY STR(iRec/AW_NAMEN->(LASTREC()) * 100, 14) + "%"
      ENDDO
      @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung
   ENDIF
   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Namenauswertung"  + CRLF + ;
           "Z=90"                   + CRLF,  ;
           "AW_NAMEN.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_NAMEN.DEF")
      FERASE("AW_NAMEN.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
