// ---------------------------------------------------------------------------
// Namen - Orte - Zeitraum
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_noz()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_NOZ.DBF"
LOCAL sFileIdx:= "AW_NOZ.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sName, sNamTyp
LOCAL sOrt, iJahr

LOCAL fGPFok
LOCAL iRec

LOCAL iPrnBreite, iMaxName, iMaxOrt, iLen
LOCAL aNamen := {}
LOCAL aOrte  := {}
LOCAL i,j

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Analyse"
   @ 14,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Name - Ort - Zeitraum", "Ort - Name - Zeitraum"})

   IF i = 1
      @ 4,0  SAY "Name - Orte - Zeitraum Auswertung"
      sListTyp := "NOZ"
   ELSEIF i = 2
      @ 4,0  SAY "Orte - Name - Zeitraum Auswertung"
      sListTyp := "ONZ"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPNOZ.GDF")
      fehler("Datei 'EXPORT\GPNOZ.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPNOZ.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPNOZ.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_NOZ.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"NAME"   ,"C", 60, 0})
   AADD(aDbf, {"ORT"    ,"C", 60, 0})
   AADD(aDbf, {"VON"    ,"N",  4, 0})
   AADD(aDbf, {"BIS"    ,"N",  4, 0})

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_NOZ EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(AW_NOZ->NAME + AW_NOZ->ORT) TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer   := .F.
   sTag   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz


         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF LEN(aNamen) > 0 .AND. ;
            LEN(aOrte)  > 0

            SELECT AW_NOZ
            FOR i := 1 TO LEN(aNamen)
               FOR j := 1 TO LEN(aOrte)
                  SEEK PADR(UPPER(aNamen[i]), 60) + ;
                       PADR(UPPER(aOrte[j,1]), 60)

                  IF ! FOUND()
                     APPEND BLANK
                     AW_NOZ->NAME := aNamen[i]
                     AW_NOZ->ORT  := aOrte[j, 1]
                     AW_NOZ->VON  := aOrte[j, 2]
                  ELSE
                     IF EMPTY(AW_NOZ->BIS)
                        IF AW_NOZ->VON < aOrte[j, 2]
                           AW_NOZ->BIS := aOrte[j, 2]
                        ELSEIF AW_NOZ->VON > aOrte[j, 2]
                           AW_NOZ->BIS := AW_NOZ->VON
                           AW_NOZ->VON := aOrte[j, 2]
                        ENDIF
                     ENDIF
                  ENDIF
               NEXT  // j, aOrte
            NEXT  // i, aNamen
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         aNamen := {} ; aOrte  := {}

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.NAME"
               IF "," $ sZeile         // Namenszustze und Adelstitel ignorieren
                  sZeile := PADR(SUBS(sZeile, 1, AT(",", sZeile)-1), 60)
               ELSE
                  sZeile := PADR(sZeile, 60)
               ENDIF

               IF ! EMPTY(sZeile)
                  sName := sZeile

                  // Wenn kein Namentyp angegeben wurde, automatisch
                  // auf Geburtsnamen annehmen
                  sNamTyp := "#0"

                  // Alle Eintrge zum Namen abarbeiten ...
                  cAltLevel := cLevel
                  fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

                  DO WHILE cAltLevel < cLevel .AND. fGPFok
                     IF sTag == "GP.NAME.TYP"
                        sNamTyp := sZeile
                     ENDIF
                     fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
                  ENDDO

                  // Bestimmte Namentypen werden unterdrckt, da die
                  // Aufnahme in diese Auswertung sinnlos ist

                  IF sNamTyp != "#1" .AND. ;     // Stamname
                     sNamTyp != "#H" .AND. ;     // Stamm : a.d.H.
                     sNamTyp != "#2" .AND. ;     // vorangest. Adelstitel
                     sNamTyp != "#B" .AND. ;     // Beiname
                     ! EMPTY(sName)              // na ja, und ein Name mu schon da sein

                     AADD(aNamen, sName)         // in Zwischenspeicher bernehmen
                  ENDIF
               ENDIF
            ELSEIF SUBS(sTag,1,7) == "GP.SACH"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               iJahr := 0
               sOrt  := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     iJahr := VAL(SUBS(sZeile,1,4))
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sOrt) .AND. ;
                  iJahr > 0

                  AADD(aOrte, {sOrt, iJahr})     // in Zwischenspeicher bernehmen
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_NOZ->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ermittlung der Ausdruckbreite
   // ---------------------------------------------------------------------------
   SELECT AW_NOZ
   GO TOP

   iRec     := 1
   iMaxName := 1
   iMaxOrt  := 1

   DO WHILE ! AW_NOZ->(EOF())

      iLen := LEN(ALLTRIM(AW_NOZ->NAME))
      IF iLen > iMaxName ; iMaxName := iLen ; ENDIF

      iLen := LEN(ALLTRIM(AW_NOZ->ORT))
      IF iLen > iMaxOrt ; iMaxOrt := iLen ; ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 13,30 SAY STR(iRec/AW_NOZ->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // Maximale Druckbreite =
   // Namenlnge + Trennzeichen + Ortslnge + Trennzeichen + von-bis
   iPrnBreite := iMaxName + 4 + iMaxOrt + 4 + 11

   IF sListTyp == "ONZ"
      // Andere Sortierung ...
      SELECT AW_NOZ
      SET INDEX TO
      INDEX ON UPPER(AW_NOZ->ORT + AW_NOZ->NAME) TO (sFileIdx)
   ENDIF

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_NOZ
   GO TOP

   iRec := 1

   // ---------------------------------------------------------------------------
   // Alle Namen
   // ---------------------------------------------------------------------------
   DO WHILE ! AW_NOZ->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      // ^# wird z.:B. fr WordPerfect Druck in TAB umgesetzt!
      IF sListTyp == "NOZ"
         sZeile := PADR(AW_NOZ->NAME, iMaxName) + "    ^#" +;
                   PADR(AW_NOZ->ORT,  iMaxOrt)  + "    ^#" +;
                   STR(AW_NOZ->VON, 4)                  +;
                   IF(!EMPTY(AW_NOZ->BIS),"  ^#" + STR(AW_NOZ->BIS, 4),"")
      ELSE
         sZeile := PADR(AW_NOZ->ORT,  iMaxOrt)  + "    ^#" +;
                   PADR(AW_NOZ->NAME, iMaxName) + "    ^#" +;
                   STR(AW_NOZ->VON, 4)                  +;
                   IF(!EMPTY(AW_NOZ->BIS),"  ^#" + STR(AW_NOZ->BIS, 4),"")
      ENDIF

      IF ! FWRITELINE(iHdlPrn, sZeile)
         BREAK
      ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 14,30 SAY STR(iRec/AW_NOZ->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 14,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   IF sListTyp == "NOZ"
      STRFILE("FRM=2"                  + CRLF + ;
              "VER=" + sVer            + CRLF + ;
              "TITEL=Namen^-^Orte^-^Zeitraum^Auswertung"  + CRLF + ;
              "Z=" + ISTR(iPrnBreite+2)                   + CRLF,  ;    // zus.  Luft
              "AW_NOZ.DEF")
   ELSE
      STRFILE("FRM=2"                  + CRLF + ;
              "VER=" + sVer            + CRLF + ;
              "TITEL=Namen^-^Orte^-^Zeitraum^Auswertung"  + CRLF + ;
              "Z=" + ISTR(iPrnBreite+2)                   + CRLF,  ;    // zus.  Luft
              "AW_NOZ.DEF")
   ENDIF

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_NOZ.DEF")
      FERASE("AW_NOZ.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
