// ---------------------------------------------------------------------------
// Orte - Personenbersicht
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_OP()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_OP.DBF"
LOCAL sFileDbt:= "AW_OP.DBT"
LOCAL sFileIdx:= "AW_OP.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer, sPerSort
LOCAL sOrt

LOCAL fGPFok
LOCAL iRec

LOCAL aOrte  := {}
LOCAL i

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Orte - Personen (Kompakt)", "Orte - Personen (bersicht)"})

   IF i = 1
      @ 4,0  SAY "Orte - Personen in der Kompaktausgabe"
      sListTyp := "KOMP"
   ELSEIF i = 2
      @ 4,0  SAY "Orte - Personen in der bersichtausgabe"
      sListTyp := "UEB"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPOP_.GDF")
      fehler("Datei 'EXPORT\GPOP_.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPOP_.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPOP_.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_OP.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"ORT"        ,"C",  60, 0})
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_OP EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(AW_OP->ORT + AW_OP->PERSORT) TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sPerSort := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF LEN(aOrte)  > 0   .AND. ;
            ! EMPTY(sPer)     .AND. ;
            ! EMPTY(sPerSort)

            SELECT AW_OP
            FOR i := 1 TO LEN(aOrte)
               SEEK PADR(UPPER(aOrte[i]), 60) + ;
                     PADR(sPerSort, 150)

               IF ! FOUND()
                  APPEND BLANK
                  AW_OP->ORT      := aOrte[i]
                  AW_OP->PERSORT  := sPerSort
                  AW_OP->PERSON   := sPer
               ENDIF
            NEXT  // i, aOrte
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         aOrte  := {}

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.SORT"
               sPerSort := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP"
               IF sListTyp == "KOMP"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB"
               IF sListTyp == "UEB"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF SUBS(sTag,1,7) == "GP.SACH"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               sOrt  := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "PLAC"
                     sOrt := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sOrt)
                  AADD(aOrte, sOrt)
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_OP->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_OP
   GO TOP

   iRec := 1

   DO WHILE ! AW_OP->(EOF())

      IF ! FWRITELINE(iHdlPrn, "#R")      // Absatzformatierungen zurcksetzen
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, ALLTRIM(AW_OP->ORT))
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=4")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF

      sOrt := AW_OP->ORT

      DO WHILE ! AW_OP->(EOF()) .AND. ;
               sOrt == AW_OP->ORT

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         // "^#" ist z.B. fr den WP Druck wichtig.  Dann wird
         // eine Einrckung gesendet, so da eine optimale Formatierung
         // mglich ist
         IF ! FWRITELINE(iHdlPrn, "^#" + AW_OP->PERSON)
            BREAK
         ENDIF

         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 13,30 SAY STR(iRec/AW_OP->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Orte^-^Personenbersicht"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_OP.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_OP.DEF")
      FERASE("AW_OP.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
