// ---------------------------------------------------------------------------
// Paten - Personenbersicht
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_paten()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_PAT.DBF"
LOCAL sFileDbt:= "AW_PAT.DBT"
LOCAL sFileIdx:= "AW_PAT.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer, sPerSort
LOCAL sPat, sPatSort, sPatKz
LOCAL aPaten  := {}

LOCAL fGPFok
LOCAL iRec

LOCAL i

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Kompakt", "bersicht"})

   IF i = 1
      @ 4,0  SAY "Paten - Personen in der Kompaktausgabe"
      sListTyp := "KOMP"
   ELSEIF i = 2
      @ 4,0  SAY "Paten - Personen in der bersichtausgabe"
      sListTyp := "UEB"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_PAT.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"PATSORT"    ,"C", 150, 0})
   AADD(aDbf, {"PATE"       ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_PAT EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON AW_PAT->PATSORT + AW_PAT->PERSORT TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sPerSort := ""
   sPat     := ""
   sPatSort := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF LEN(aPaten)  > 0   .AND. ;
            ! EMPTY(sPer)      .AND. ;
            ! EMPTY(sPerSort)

            SELECT AW_PAT
            FOR i := 1 TO LEN(aPaten)
               SEEK PADR(UPPER(aPaten[i,1]), 150) + ;
                    PADR(sPerSort, 150)

               IF ! FOUND()
                  APPEND BLANK
                  AW_PAT->PATSORT  := aPaten[i,1]
                  AW_PAT->PATE     := aPaten[i,2]
                  AW_PAT->PERSORT  := sPerSort
                  AW_PAT->PERSON   := sPer
               ENDIF
            NEXT  // i, aPaten
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         aPaten   := {}
         sPer     := ""
         sPerSort := ""

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.SORT"
               sPerSort := sZeile
               fGPFok   := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP"
               IF sListTyp == "KOMP"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB"
               IF sListTyp == "UEB"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.PAT"
               sPat     := ""
               sPatSort := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.SORT.PAT"
                     sPatSort := sZeile
                  ELSEIF sTag == "GP.DAR.KOMP.PAT"
                     IF sListTyp == "KOMP"
                        sPat := sZeile
                     ENDIF
                  ELSEIF sTag == "GP.DAR.UEB.PAT"
                     IF sListTyp == "UEB"
                        sPat := sZeile
                     ENDIF
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sPat) .AND. ;
                  ! EMPTY(sPatSort)
                  AADD(aPaten, {sPatSort, sPat})
               ENDIF

            ELSEIF sTag == "GP.SACH.#906"

               // Alle Eintrge zum pateneintrag abarbeiten ...
               sPat   := ""
               sPatKz := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAR.SACH"
                     sPat := sZeile
                  ELSEIF sTag == "GP.SACH.KZ"
                     sPatKz := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sPatKz)

                  // Die Sachgebietsdarstellung fngt mit dem Sachgebietdkennzeichen
                  // an, das sollte aber in diesem Fall entfernt werden.

                  sPat := SUBS(sPat, LEN(sPatKz) + 2)
               ENDIF

               IF ! EMPTY(sPat)
                  AADD(aPaten, {UPPER(sPat), sPat})
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_PAT->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_PAT
   GO TOP

   iRec := 1

   DO WHILE ! AW_PAT->(EOF())

      IF ! FWRITELINE(iHdlPrn, "#R")      // Absatzformatierungen zurcksetzen
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=0")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, ALLTRIM(AW_PAT->PATE))
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=4")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF

      sPat := AW_PAT->PATSORT

      DO WHILE ! AW_PAT->(EOF()) .AND. ;
               sPat == AW_PAT->PATSORT

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         // "^#" ist z.B. fr den WP Druck wichtig.  Dann wird
         // eine Einrckung gesendet, so da eine optimale Formatierung
         // mglich ist
         IF ! FWRITELINE(iHdlPrn, "^#" + AW_PAT->PERSON)
            BREAK
         ENDIF

         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 13,30 SAY STR(iRec/AW_PAT->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Paten^-^Personenbersicht"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_PAT.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_PAT.DEF")
      FERASE("AW_PAT.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
