// ---------------------------------------------------------------------------
// Einfache, einzeilige Personenliste aus einfacher dBase Datei
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_pl1()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdlPrn := 0
LOCAL sFile   := "EXPORT\GPEXP_P.DBF"
LOCAL sFileIdx:= "EXPORT\GPEXP_P.NTX"

LOCAL fOk     := .F.
LOCAL iRec
LOCAL sZeile  := ""

LOCAL iPrnBreite, iMaxOrt, iLen
LOCAL i,j

LOCAL iNamenLen

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Einfache einzeilige Personenliste"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Datenstze"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Analyse"
   @ 14,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Sortierung", ;
              {"Name - Vorname - Datum", "Name - Datum - Vorname"})

   IF i = 1
      @ 6,0  SAY "Sortierung : Name - Vorname - Datum"
      sListTyp := "NVD"
   ELSEIF i = 2
      @ 6,0  SAY "Sortierung : Name - Datum - Vorname"
      sListTyp := "NDV"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE(sFile)
      fehler("Datei '" + sFile + "' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   USE (sFile) ALIAS PERSONEN NEW EXCLUSIVE
   IF NETERR()
      fehler("Datei '" + sFile + "' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   iNamenLen := LEN(PERSONEN->NAME)

   IF sListTyp == "NVD"
      INDEX ON PADR(UPPER(IF("," $ PERSONEN->NAME, SUBS(PERSONEN->NAME, 1, AT(",", PERSONEN->NAME)-1), PERSONEN->NAME)), iNamenLen) + ;
               UPPER(PERSONEN->VNAMEN) + ;
               PERSONEN->S001_D_V ;
               TO (sFileIdx)
   ELSE
      INDEX ON PADR(UPPER(IF("," $ PERSONEN->NAME, SUBS(PERSONEN->NAME, 1, AT(",", PERSONEN->NAME)-1), PERSONEN->NAME)), iNamenLen) + ;
               PERSONEN->S001_D_V + ;
               UPPER(PERSONEN->VNAMEN) ;
               TO (sFileIdx)
   ENDIF

   // ------------------------------------------------------------------------
   // Umfang anzeigen ...
   // ------------------------------------------------------------------------
   @ 7,30 SAY STR(PERSONEN->(LASTREC()), 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_PL1.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ---------------------------------------------------------------------------
   // Ermittlung der Ausdruckbreite
   // ---------------------------------------------------------------------------
   SELECT PERSONEN
   GO TOP

   iRec     := 1
   iMaxOrt  := 1

   DO WHILE ! PERSONEN->(EOF())

      iLen := LEN(ALLTRIM(PERSONEN->S001_O_ORT))
      IF iLen > iMaxOrt ; iMaxOrt := iLen ; ENDIF

      iLen := LEN(ALLTRIM(PERSONEN->S003_O_ORT))
      IF iLen > iMaxOrt ; iMaxOrt := iLen ; ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 13,30 SAY STR(iRec/PERSONEN->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // Maximale Druckbreite =
   // Namenlnge + Trennzeichen + Ortslnge + Trennzeichen + von-bis
   iPrnBreite := LEN(PERSONEN->NAME)   + ;
                 LEN(PERSONEN->VNAMEN) + ;
                 2 * iMaxOrt           + ;
                 2 * 10                + ;      // Datum
                 8                              // Zwischenrume

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT PERSONEN
   GO TOP

   iRec := 1

   DO WHILE ! PERSONEN->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      sZeile := PERSONEN->NAME   + " ^#" +;
                PERSONEN->VNAMEN + " ^#"

      IF VAL(PERSONEN->S001_D_V) > 0
         sZeile += "*" + SUBS(PERSONEN->S001_D_V,1,4) + "." +;
                         SUBS(PERSONEN->S001_D_V,5,2) + "." +;
                         SUBS(PERSONEN->S001_D_V,7,2) + " ^#"
      ELSE
         sZeile += SPACE(11) + "^#"
      ENDIF
      sZeile += SUBS(PERSONEN->S001_O_ORT, 1, iMaxOrt) + " ^#"

      IF VAL(PERSONEN->S003_D_V) > 0
         sZeile += "+" + SUBS(PERSONEN->S003_D_V,1,4) + "." +;
                         SUBS(PERSONEN->S003_D_V,5,2) + "." +;
                         SUBS(PERSONEN->S003_D_V,7,2) + " ^#"
      ELSE
         sZeile += SPACE(11) + "^#"
      ENDIF
      sZeile += ALLTRIM(SUBS(PERSONEN->S003_O_ORT, 1, iMaxOrt))

      IF ! FWRITELINE(iHdlPrn, sZeile)
         BREAK
      ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 14,30 SAY STR(iRec/PERSONEN->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 14,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Personenbersicht"  + CRLF + ;
           "Z=" + ISTR(iPrnBreite+2)                   + CRLF,  ;    // zus.  Luft
           "AW_PL1.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFileIdx)                    // Hilfsdatei wird nicht mehr bentigt
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_PL1.DEF")
      FERASE("AW_PL1.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------
