// ---------------------------------------------------------------------------
// Quellen - Personenbersicht
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_qp()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_QP.DBF"
LOCAL sFileDbt:= "AW_QP.DBT"
LOCAL sFileIdx:= "AW_QP.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer, sPerSort
LOCAL sQuelle, sRegNr, sSeite, sPos

LOCAL fGPFok
LOCAL iRec

LOCAL aQuelle  := {}
LOCAL i

LOCAL sListTyp
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   i := ALERT("Ausgabevariante", ;
              {"Quellen-Personen (komp)", "Quellen-Personen (bers)"})

   IF i = 1
      @ 4,0  SAY "Quellen - Personen in der Kompaktausgabe"
      sListTyp := "KOMP"
   ELSEIF i = 2
      @ 4,0  SAY "Quellen - Personen in der bersichtausgabe"
      sListTyp := "UEB"
   ELSE
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPQP_.GDF")
      fehler("Datei 'EXPORT\GPQP_.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPQP_.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPQP_.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_QP.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"QUELLE"     ,"C",  60, 0})
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"SEITE"      ,"M",  10, 0})

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_QP EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(AW_QP->QUELLE + AW_QP->PERSORT) TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sPerSort := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF LEN(aQuelle)  > 0   .AND. ;
            ! EMPTY(sPer)     .AND. ;
            ! EMPTY(sPerSort)

            SELECT AW_QP
            FOR i := 1 TO LEN(aQuelle)
               SEEK PADR(UPPER(aQuelle[i,1]), 60) + ;
                     PADR(sPerSort, 150)

               IF ! FOUND()
                  APPEND BLANK
                  AW_QP->QUELLE   := aQuelle[i,1]
                  AW_QP->PERSORT  := sPerSort
                  AW_QP->PERSON   := sPer
               ENDIF

               IF ! EMPTY(aQuelle[i,2])
                  IF EMPTY(AW_QP->SEITE)
                     AW_QP->SEITE := aQuelle[i,2]
                  ELSE
                     AW_QP->SEITE += CRLF + aQuelle[i,2]
                  ENDIF
               ENDIF

            NEXT  // i, aQuelle
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         aQuelle  := {}

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.SORT"
               sPerSort := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP"
               IF sListTyp == "KOMP"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB"
               IF sListTyp == "UEB"
                  sPer := sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.Q"

               // Alle Eintrge zur Quelle abarbeiten ...
               sQuelle  := ""
               sRegNr   := ""
               sSeite   := ""
               sPos     := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.Q.QUELLE"
                     sQuelle := sZeile
                  ELSEIF sTag == "GP.Q.SEITE"
                     sSeite := sZeile
                  ELSEIF sTag == "GP.Q.POS"
                     sPos := sZeile
                  ELSEIF sTag == "GP.Q.REG"
                     sRegNr := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sQuelle)

                  IF ! EMPTY(sSeite)
                     sSeite := "S" + ALLTRIM(sSeite)
                     IF ! EMPTY(sPos)
                        sSeite += "/" + ALLTRIM(sPos)
                     ENDIF
                  ENDIF

                  IF ! EMPTY(sRegNr)
                     sRegNr := ALLTRIM(sRegNr)

                     IF ! EMPTY(sSeite)
                        sRegNr += " " + sSeite
                     ENDIF
                  ELSE
                     sRegNr := sSeite
                  ENDIF

                  AADD(aQuelle, {sQuelle, sRegNr})
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_QP->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_QP
   GO TOP

   iRec := 1

   DO WHILE ! AW_QP->(EOF())

      IF ! FWRITELINE(iHdlPrn, "#R")      // Absatzformatierungen zurcksetzen
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, ALLTRIM(AW_QP->QUELLE))
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=4")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF

      sQuelle := AW_QP->QUELLE

      DO WHILE ! AW_QP->(EOF()) .AND. ;
               sQuelle == AW_QP->QUELLE

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         // "^#" ist z.B. fr den WP Druck wichtig.  Dann wird
         // eine Einrckung gesendet, so da eine optimale Formatierung
         // mglich ist
         IF sListTyp == "KOMP"
            IF ! FWRITELINE(iHdlPrn, "^#" + AW_QP->PERSON + ;
                                     IF(!EMPTY(AW_QP->SEITE), ;
                                        " ^#" + sortQuelle(AW_QP->SEITE),;
                                        ""))
               BREAK
            ENDIF
         ELSE
            IF ! FWRITELINE(iHdlPrn, "^#" + AW_QP->PERSON)
               BREAK
            ENDIF
            IF ! EMPTY(AW_QP->SEITE)
               IF ! FWRITELINE(iHdlPrn, "#ABS_LR=6")   ; BREAK ; ENDIF
               IF ! FWRITELINE(iHdlPrn, "^#^#" + "^Esiehe^F : " + ;
                                        sortQuelle(AW_QP->SEITE))
                  BREAK
               ENDIF
               IF ! FWRITELINE(iHdlPrn, "#ABS_LR=4")   ; BREAK ; ENDIF
            ENDIF
         ENDIF
         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 13,30 SAY STR(iRec/AW_QP->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Quellen^-^Personenbersicht"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_QP.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_QP.DEF")
      FERASE("AW_QP.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
static FUNCTION sortQuelle(sQuelle)
// ---------------------------------------------------------------------------

LOCAL sRet := ""
LOCAL iNum, i, j
LOCAL sZeile
LOCAL aQuelle := {}

LOCAL fAdd

   iNum := MLCOUNT(sQuelle, 200)

   FOR i := 1 TO iNum
      sZeile := ALLTRIM(MEMOLINE(sQuelle, 200, i))

      IF ! EMPTY(sZeile)

         fAdd  := .T.

         FOR j := 1 TO LEN(aQuelle)

            IF UPPER(aQuelle[j]) == UPPER(sZeile)
               fAdd  := .F.
               EXIT
            ENDIF
         NEXT

         IF fAdd
            AADD(aQuelle, sZeile)
         ENDIF
      ENDIF
   NEXT

   ASORT(aQuelle)

   FOR i := 1 TO LEN(aQuelle)
      IF EMPTY(sRet)
         sRet := aQuelle[i]
      ELSE
         sRet += ", " + aQuelle[i]
      ENDIF
   NEXT

RETURN(sRet)
// ---------------------------------------------------------------------------
