// ---------------------------------------------------------------------------
// Statistik
//
// Hinweis : Dieses Programm ist speziell auf bersichtlichkeit
//           entwickelt worden. Einzelne Auswertungen wurden in
//           untergeordnete Funktionen aufgeteilt. Auf diese
//           Weise knnen einfach weitere Auswertungen entwickelt
//           werden.
//
// ---------------------------------------------------------------------------

#include "std.ch"


#define    PRINTZEILE(s)        IF ! FWRITELINE(iHdlPrn, s) ; BREAK ; ENDIF
#define    LEERZEILE()          IF ! FWRITELINE(iHdlPrn,"") ; BREAK ; ENDIF
#define    CSTR(i,l)            PADC(ALLTRIM(STR(i)), l)

// ---------------------------------------------------------------------------
PROCEDURE aw_stat()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdlPrn := 0
LOCAL sFilePer:= "EXPORT\GPEXP_P.DBF"
LOCAL sFileFam:= "EXPORT\GPEXP_F.DBF"
LOCAL sFileSt := "EXPORT\STAT.DBF"

LOCAL fOk     := .F.
LOCAL iRec
LOCAL sZeile  := ""

LOCAL iAlter, sAlter

LOCAL i,j
LOCAL aDbf
LOCAL iMonat

#define ST_MAS     1
#define ST_FEM     2
#define ST_NEU     3

LOCAL aAnz    := {0,0,0}

#define ST_ALT_1   1
#define ST_ALT_5   2
#define ST_ALT_10  3
#define ST_ALT_20  4
#define ST_ALT_30  5
#define ST_ALT_40  6
#define ST_ALT_50  7
#define ST_ALT_60  8
#define ST_ALT_70  9
#define ST_ALT_X   10

LOCAL aAltM   := {0,0,0,0,0,0,0,0,0,0}
LOCAL aAltW   := {0,0,0,0,0,0,0,0,0,0}

#define ST_ALT_E15  1
#define ST_ALT_E20  2
#define ST_ALT_E30  3
#define ST_ALT_E40  4
#define ST_ALT_E50  5
#define ST_ALT_E60  6
#define ST_ALT_EX   7

LOCAL aAlt1EM := {0,0,0,0,0,0,0}
LOCAL aAlt1EW := {0,0,0,0,0,0,0}
LOCAL aAlt1KM := {0,0,0,0,0,0,0}
LOCAL aAlt1KW := {0,0,0,0,0,0,0}

LOCAL aAnzKEM := {0,0,0,0,0,0,0,0,0,0,0,0,0}
LOCAL aAnzKEW := {0,0,0,0,0,0,0,0,0,0,0,0,0}
LOCAL aAnzKUM := {0,0,0,0,0,0,0,0,0,0,0,0,0}
LOCAL aAnzKUW := {0,0,0,0,0,0,0,0,0,0,0,0,0}

LOCAL aAnzVEM := {0,0,0,0,0,0,0}
LOCAL aAnzVEW := {0,0,0,0,0,0,0}
LOCAL aAnzVUM := {0,0,0,0,0,0,0}
LOCAL aAnzVUW := {0,0,0,0,0,0,0}

LOCAL aGeb  := {0,0,0,0,0,0,0,0,0,0,0,0}
LOCAL aTauf := {0,0,0,0,0,0,0,0,0,0,0,0}
LOCAL aKhei := {0,0,0,0,0,0,0,0,0,0,0,0}
LOCAL aShei := {0,0,0,0,0,0,0,0,0,0,0,0}
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Statistik"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Datenstze"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"
   @ 11,0 SAY "Stand der Analyse Personen"

   @ 13,0 SAY "Anzahl Familien"
   @ 14,0 SAY "Stand der Analyse Familien"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE(sFilePer)
      fehler("Datei '" + sFilePer + "' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   USE (sFilePer) ALIAS PERSONEN NEW EXCLUSIVE
   IF NETERR()
      fehler("Datei '" + sFilePer + "' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   IF ! FILE(sFileFam)
      fehler("Datei '" + sFileFam + "' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   USE (sFileFam) ALIAS FAMILIEN NEW EXCLUSIVE
   IF NETERR()
      fehler("Datei '" + sFileFam + "' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Umfang anzeigen ...
   // ------------------------------------------------------------------------
   @ 10,30 SAY STR(PERSONEN->(LASTREC()), 15, 0)
   @ 13,30 SAY STR(FAMILIEN->(LASTREC()), 15, 0)

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFileSt)                    // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"WERT"   ,"C", 20, 0})
   AADD(aDbf, {"ANZAHL" ,"N",  7, 0})

   DBCREATE(sFileSt, aDbf)

   IF FILE(sFileSt)
      USE (sFileSt) ALIAS EXPORT EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_STAT.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF


   // ---------------------------------------------------------------------------
   // Analyse
   // ---------------------------------------------------------------------------
   SELECT PERSONEN
   GO TOP

   iRec := 1

   DO WHILE ! PERSONEN->(EOF())

      IF PERSONEN->SEX == "?"
         aAnz[ST_NEU]++
         SKIP
         LOOP
      ENDIF

      // ---------------------------------------------------------------------
      // Personen zhlen
      // ---------------------------------------------------------------------
      IF PERSONEN->SEX == "M"
         aAnz[ST_MAS]++
      ELSEIF PERSONEN->SEX == "F"
         aAnz[ST_FEM]++
      ENDIF

      // ---------------------------------------------------------------------
      // Altersangabe prfen
      // ---------------------------------------------------------------------
      sAlter := ALLTRIM(PERSONEN->ALT)

      IF ! EMPTY(sAlter) .AND. ;
         sAlter != "?"

         iAlter := VAL(SUBS(sAlter,1,3))

         DO CASE
         CASE iAlter <= 1
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_1 ]++ , aAltW[ST_ALT_1 ]++)
         CASE iAlter <= 5
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_5 ]++ , aAltW[ST_ALT_5 ]++)
         CASE iAlter <= 10
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_10]++ , aAltW[ST_ALT_10]++)
         CASE iAlter <= 20
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_20]++ , aAltW[ST_ALT_20]++)
         CASE iAlter <= 30
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_30]++ , aAltW[ST_ALT_30]++)
         CASE iAlter <= 40
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_40]++ , aAltW[ST_ALT_40]++)
         CASE iAlter <= 50
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_50]++ , aAltW[ST_ALT_50]++)
         CASE iAlter <= 60
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_60]++ , aAltW[ST_ALT_60]++)
         CASE iAlter <= 70
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_70]++ , aAltW[ST_ALT_70]++)
         OTHERWISE
            IF(PERSONEN->SEX == "M",aAltM[ST_ALT_X ]++ , aAltW[ST_ALT_X ]++)
         ENDCASE
      ENDIF

      // ---------------------------------------------------------------------
      // Alter bei 1. Ehe prfen
      // ---------------------------------------------------------------------
      sAlter := ALLTRIM(PERSONEN->ALTE1)

      IF ! EMPTY(sAlter) .AND. ;
         sAlter != "?"

         iAlter := VAL(SUBS(sAlter,1,3))

         DO CASE
         CASE iAlter <= 15
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_E15]++ , aAlt1EW[ST_ALT_E15]++)
         CASE iAlter <= 20
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_E20]++ , aAlt1EW[ST_ALT_E20]++)
         CASE iAlter <= 30
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_E30]++ , aAlt1EW[ST_ALT_E30]++)
         CASE iAlter <= 40
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_E40]++ , aAlt1EW[ST_ALT_E40]++)
         CASE iAlter <= 50
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_E50]++ , aAlt1EW[ST_ALT_E50]++)
         CASE iAlter <= 60
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_E60]++ , aAlt1EW[ST_ALT_E60]++)
         OTHERWISE
            IF(PERSONEN->SEX == "M",aAlt1EM[ST_ALT_EX ]++ , aAlt1EW[ST_ALT_EX ]++)
         ENDCASE
      ENDIF

      // ---------------------------------------------------------------------
      // Alter bei 1. Kind prfen
      // ---------------------------------------------------------------------
      sAlter := ALLTRIM(PERSONEN->ALTK1)

      IF ! EMPTY(sAlter) .AND. ;
         sAlter != "?"

         iAlter := VAL(SUBS(sAlter,1,3))

         DO CASE
         CASE iAlter <= 15
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_E15]++ , aAlt1KW[ST_ALT_E15]++)
         CASE iAlter <= 20
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_E20]++ , aAlt1KW[ST_ALT_E20]++)
         CASE iAlter <= 30
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_E30]++ , aAlt1KW[ST_ALT_E30]++)
         CASE iAlter <= 40
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_E40]++ , aAlt1KW[ST_ALT_E40]++)
         CASE iAlter <= 50
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_E50]++ , aAlt1KW[ST_ALT_E50]++)
         CASE iAlter <= 60
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_E60]++ , aAlt1KW[ST_ALT_E60]++)
         OTHERWISE
            IF(PERSONEN->SEX == "M",aAlt1KM[ST_ALT_EX ]++ , aAlt1KW[ST_ALT_EX ]++)
         ENDCASE
      ENDIF

      // ---------------------------------------------------------------------
      // Anzahl ehelicher Kinder
      // ---------------------------------------------------------------------
      IF PERSONEN->ANZ_K_EHE > 0
         IF PERSONEN->ANZ_K_EHE <= 10
            IF PERSONEN->SEX == "M"
               aAnzKEM[PERSONEN->ANZ_K_EHE]++
            ELSE
               aAnzKEW[PERSONEN->ANZ_K_EHE]++
            ENDIF
         ELSEIF PERSONEN->ANZ_K_EHE <= 15
            IF PERSONEN->SEX == "M"
               aAnzKEM[11]++
            ELSE
               aAnzKEW[11]++
            ENDIF
         ELSEIF PERSONEN->ANZ_K_EHE <= 20
            IF PERSONEN->SEX == "M"
               aAnzKEM[12]++
            ELSE
               aAnzKEW[12]++
            ENDIF
         ELSE
            IF PERSONEN->SEX == "M"
               aAnzKEM[13]++
            ELSE
               aAnzKEW[13]++
            ENDIF
         ENDIF
      ENDIF

      // ---------------------------------------------------------------------
      // Anzahl unehelicher Kinder
      // ---------------------------------------------------------------------
      IF PERSONEN->ANZ_K_UEHE > 0
         IF PERSONEN->ANZ_K_UEHE <= 10
            IF PERSONEN->SEX == "M"
               aAnzKUM[PERSONEN->ANZ_K_UEHE]++
            ELSE
               aAnzKUW[PERSONEN->ANZ_K_UEHE]++
            ENDIF
         ELSEIF PERSONEN->ANZ_K_UEHE <= 15
            IF PERSONEN->SEX == "M"
               aAnzKUM[11]++
            ELSE
               aAnzKUW[11]++
            ENDIF
         ELSEIF PERSONEN->ANZ_K_UEHE <= 20
            IF PERSONEN->SEX == "M"
               aAnzKUM[12]++
            ELSE
               aAnzKUW[12]++
            ENDIF
         ELSE
            IF PERSONEN->SEX == "M"
               aAnzKUM[13]++
            ELSE
               aAnzKUW[13]++
            ENDIF
         ENDIF
      ENDIF

      // ---------------------------------------------------------------------
      // Anzahl ehelicher Verbindungen
      // ---------------------------------------------------------------------
      IF PERSONEN->ANZ_EHE > 0
         IF PERSONEN->ANZ_EHE < 7
            IF PERSONEN->SEX == "M"
               aAnzVEM[PERSONEN->ANZ_EHE]++
            ELSE
               aAnzVEW[PERSONEN->ANZ_EHE]++
            ENDIF
         ELSE
            IF PERSONEN->SEX == "M"
               aAnzVEM[7]++
            ELSE
               aAnzVEW[7]++
            ENDIF
         ENDIF
      ENDIF

      // ---------------------------------------------------------------------
      // Anzahl unehelicher Verbindungen
      // ---------------------------------------------------------------------
      IF PERSONEN->ANZ_UEHE > 0
         IF PERSONEN->ANZ_UEHE < 7
            IF PERSONEN->SEX == "M"
               aAnzVUM[PERSONEN->ANZ_UEHE]++
            ELSE
               aAnzVUW[PERSONEN->ANZ_UEHE]++
            ENDIF
         ELSE
            IF PERSONEN->SEX == "M"
               aAnzVUM[7]++
            ELSE
               aAnzVUW[7]++
            ENDIF
         ENDIF
      ENDIF

      iMonat := VAL(SUBS(PERSONEN->S001_D_V,5,2))
      IF iMonat > 0 .AND. iMonat <= 12
         aGeb[iMonat]++
      ENDIF

      iMonat := VAL(SUBS(PERSONEN->S002_D_V,5,2))
      IF iMonat > 0 .AND. iMonat <= 12
         aTauf[iMonat]++
      ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
      iRec ++
      SKIP

      @ 11,30 SAY STR(iRec/PERSONEN->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 11,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   SELECT FAMILIEN
   GO TOP

   iRec := 1

   DO WHILE ! FAMILIEN->(EOF())

      iMonat := VAL(SUBS(FAMILIEN->S103_D_V,5,2))
      IF iMonat > 0 .AND. iMonat <= 12
         aKhei[iMonat]++
      ENDIF

      iMonat := VAL(SUBS(FAMILIEN->S102_D_V,5,2))
      IF iMonat > 0 .AND. iMonat <= 12
         aShei[iMonat]++
      ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 14,30 SAY STR(iRec/FAMILIEN->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 14,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck und bergabe der Daten in die Exportdatei
   // ---------------------------------------------------------------------------

   // Personenstatistik
   SELECT EXPORT

   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "masculinum      "  ; EXPORT->ANZAHL := aAnz[ST_MAS]
   APPEND BLANK ; EXPORT->WERT := "femininum       "  ; EXPORT->ANZAHL := aAnz[ST_FEM]
   APPEND BLANK ; EXPORT->WERT := "neutrum         "  ; EXPORT->ANZAHL := aAnz[ST_NEU]

   PRINTZEILE("^APersonen Gesamt : ^B" + ISTR(PERSONEN->(LASTREC())))
   PRINTZEILE("^Amnnlich        : ^B" + ISTR(aAnz[ST_MAS]))
   PRINTZEILE("^Aweiblich        : ^B" + ISTR(aAnz[ST_FEM]))
   PRINTZEILE("^Aunbekannt       : ^B" + ISTR(aAnz[ST_NEU]))
   PRINTZEILE("^AFamilien Gesamt : ^B" + ISTR(FAMILIEN->(LASTREC())))
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "Alter (m)       "  ; EXPORT->ANZAHL := sumArray(aAltM)
   APPEND BLANK ; EXPORT->WERT := "bis 1           "  ; EXPORT->ANZAHL := aAltM[ST_ALT_1 ]
   APPEND BLANK ; EXPORT->WERT := "bis 5           "  ; EXPORT->ANZAHL := aAltM[ST_ALT_5 ]
   APPEND BLANK ; EXPORT->WERT := "bis 10          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_10]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_20]
   APPEND BLANK ; EXPORT->WERT := "bis 30          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_30]
   APPEND BLANK ; EXPORT->WERT := "bis 40          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_40]
   APPEND BLANK ; EXPORT->WERT := "bis 50          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_50]
   APPEND BLANK ; EXPORT->WERT := "bis 60          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_60]
   APPEND BLANK ; EXPORT->WERT := "bis 70          "  ; EXPORT->ANZAHL := aAltM[ST_ALT_70]
   APPEND BLANK ; EXPORT->WERT := "lter           "  ; EXPORT->ANZAHL := aAltM[ST_ALT_X ]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "Alter (f)       "  ; EXPORT->ANZAHL := sumArray(aAltW)
   APPEND BLANK ; EXPORT->WERT := "bis 1           "  ; EXPORT->ANZAHL := aAltW[ST_ALT_1 ]
   APPEND BLANK ; EXPORT->WERT := "bis 5           "  ; EXPORT->ANZAHL := aAltW[ST_ALT_5 ]
   APPEND BLANK ; EXPORT->WERT := "bis 10          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_10]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_20]
   APPEND BLANK ; EXPORT->WERT := "bis 30          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_30]
   APPEND BLANK ; EXPORT->WERT := "bis 40          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_40]
   APPEND BLANK ; EXPORT->WERT := "bis 50          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_50]
   APPEND BLANK ; EXPORT->WERT := "bis 60          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_60]
   APPEND BLANK ; EXPORT->WERT := "bis 70          "  ; EXPORT->ANZAHL := aAltW[ST_ALT_70]
   APPEND BLANK ; EXPORT->WERT := "lter           "  ; EXPORT->ANZAHL := aAltW[ST_ALT_X ]

   PRINTZEILE("#L8")
   PRINTZEILE("^AAlter^B              bis 1    5   10   20   30   40   50   60   70lter")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAltM),5) + "    " + ;
              CSTR(aAltM[ST_ALT_1 ],5) + "" + ;
              CSTR(aAltM[ST_ALT_5 ],5) + "" + ;
              CSTR(aAltM[ST_ALT_10],5) + "" + ;
              CSTR(aAltM[ST_ALT_20],5) + "" + ;
              CSTR(aAltM[ST_ALT_30],5) + "" + ;
              CSTR(aAltM[ST_ALT_40],5) + "" + ;
              CSTR(aAltM[ST_ALT_50],5) + "" + ;
              CSTR(aAltM[ST_ALT_60],5) + "" + ;
              CSTR(aAltM[ST_ALT_70],5) + "" + ;
              CSTR(aAltM[ST_ALT_X ],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAltW),5) + "    " + ;
              CSTR(aAltW[ST_ALT_1 ],5) + "" + ;
              CSTR(aAltW[ST_ALT_5 ],5) + "" + ;
              CSTR(aAltW[ST_ALT_10],5) + "" + ;
              CSTR(aAltW[ST_ALT_20],5) + "" + ;
              CSTR(aAltW[ST_ALT_30],5) + "" + ;
              CSTR(aAltW[ST_ALT_40],5) + "" + ;
              CSTR(aAltW[ST_ALT_50],5) + "" + ;
              CSTR(aAltW[ST_ALT_60],5) + "" + ;
              CSTR(aAltW[ST_ALT_70],5) + "" + ;
              CSTR(aAltW[ST_ALT_X ],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "1. Ehe (m)      "  ; EXPORT->ANZAHL := sumArray(aAlt1EM)
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_E15]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_E20]
   APPEND BLANK ; EXPORT->WERT := "bis 30          "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_E30]
   APPEND BLANK ; EXPORT->WERT := "bis 40          "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_E40]
   APPEND BLANK ; EXPORT->WERT := "bis 50          "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_E50]
   APPEND BLANK ; EXPORT->WERT := "bis 60          "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_E60]
   APPEND BLANK ; EXPORT->WERT := "lter           "  ; EXPORT->ANZAHL := aAlt1EM[ST_ALT_EX ]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "1. Ehe (f)      "  ; EXPORT->ANZAHL := sumArray(aAlt1EW)
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_E15]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_E20]
   APPEND BLANK ; EXPORT->WERT := "bis 30          "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_E30]
   APPEND BLANK ; EXPORT->WERT := "bis 40          "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_E40]
   APPEND BLANK ; EXPORT->WERT := "bis 50          "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_E50]
   APPEND BLANK ; EXPORT->WERT := "bis 60          "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_E60]
   APPEND BLANK ; EXPORT->WERT := "lter           "  ; EXPORT->ANZAHL := aAlt1EW[ST_ALT_EX ]

   PRINTZEILE("#L8")
   PRINTZEILE("^AAlter 1. Ehe^B      bis 15   20   30   40   50   60lter")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAlt1EM),5) + "    " + ;
              CSTR(aAlt1EM[ST_ALT_E15],5) + "" + ;
              CSTR(aAlt1EM[ST_ALT_E20],5) + "" + ;
              CSTR(aAlt1EM[ST_ALT_E30],5) + "" + ;
              CSTR(aAlt1EM[ST_ALT_E40],5) + "" + ;
              CSTR(aAlt1EM[ST_ALT_E50],5) + "" + ;
              CSTR(aAlt1EM[ST_ALT_E60],5) + "" + ;
              CSTR(aAlt1EM[ST_ALT_EX ],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAlt1EW),5) + "    " + ;
              CSTR(aAlt1EW[ST_ALT_E15],5) + "" + ;
              CSTR(aAlt1EW[ST_ALT_E20],5) + "" + ;
              CSTR(aAlt1EW[ST_ALT_E30],5) + "" + ;
              CSTR(aAlt1EW[ST_ALT_E40],5) + "" + ;
              CSTR(aAlt1EW[ST_ALT_E50],5) + "" + ;
              CSTR(aAlt1EW[ST_ALT_E60],5) + "" + ;
              CSTR(aAlt1EW[ST_ALT_EX ],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "1. Kind (m)     "  ; EXPORT->ANZAHL := sumArray(aAlt1KM)
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_E15]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_E20]
   APPEND BLANK ; EXPORT->WERT := "bis 30          "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_E30]
   APPEND BLANK ; EXPORT->WERT := "bis 40          "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_E40]
   APPEND BLANK ; EXPORT->WERT := "bis 50          "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_E50]
   APPEND BLANK ; EXPORT->WERT := "bis 60          "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_E60]
   APPEND BLANK ; EXPORT->WERT := "lter           "  ; EXPORT->ANZAHL := aAlt1KM[ST_ALT_EX ]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "1. Kind (f)     "  ; EXPORT->ANZAHL := sumArray(aAlt1KW)
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_E15]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_E20]
   APPEND BLANK ; EXPORT->WERT := "bis 30          "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_E30]
   APPEND BLANK ; EXPORT->WERT := "bis 40          "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_E40]
   APPEND BLANK ; EXPORT->WERT := "bis 50          "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_E50]
   APPEND BLANK ; EXPORT->WERT := "bis 60          "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_E60]
   APPEND BLANK ; EXPORT->WERT := "lter           "  ; EXPORT->ANZAHL := aAlt1KW[ST_ALT_EX ]

   PRINTZEILE("#L8")
   PRINTZEILE("^AAlter 1. Kind^B     bis 15   20   30   40   50   60lter")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAlt1KM),5) + "    " + ;
              CSTR(aAlt1KM[ST_ALT_E15],5) + "" + ;
              CSTR(aAlt1KM[ST_ALT_E20],5) + "" + ;
              CSTR(aAlt1KM[ST_ALT_E30],5) + "" + ;
              CSTR(aAlt1KM[ST_ALT_E40],5) + "" + ;
              CSTR(aAlt1KM[ST_ALT_E50],5) + "" + ;
              CSTR(aAlt1KM[ST_ALT_E60],5) + "" + ;
              CSTR(aAlt1KM[ST_ALT_EX ],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAlt1KW),5) + "    " + ;
              CSTR(aAlt1KW[ST_ALT_E15],5) + "" + ;
              CSTR(aAlt1KW[ST_ALT_E20],5) + "" + ;
              CSTR(aAlt1KW[ST_ALT_E30],5) + "" + ;
              CSTR(aAlt1KW[ST_ALT_E40],5) + "" + ;
              CSTR(aAlt1KW[ST_ALT_E50],5) + "" + ;
              CSTR(aAlt1KW[ST_ALT_E60],5) + "" + ;
              CSTR(aAlt1KW[ST_ALT_EX ],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "ehel. Kinder (m)"  ; EXPORT->ANZAHL := sumArray(aAnzKEM)
   FOR i := 1 TO 10
      APPEND BLANK
      EXPORT->WERT   := ALLTRIM(STR(i))
      EXPORT->ANZAHL := aAnzKEM[i]
   NEXT
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAnzKEM[11]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAnzKEM[12]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzKEM[13]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "ehel. Kinder (f)"  ; EXPORT->ANZAHL := sumArray(aAnzKEW)
   FOR i := 1 TO 10
      APPEND BLANK
      EXPORT->WERT   := ALLTRIM(STR(i))
      EXPORT->ANZAHL := aAnzKEW[i]
   NEXT
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAnzKEW[11]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAnzKEW[12]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzKEW[13]

   PRINTZEILE("#L8")
   PRINTZEILE("^Aeheliche Kinder^B        1    2    3    4    5    6    7    8    9   10bis 15bis 20mehr ")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAnzKEM),5) + "    " + ;
              CSTR(aAnzKEM[ 1],5) + "" + ;
              CSTR(aAnzKEM[ 2],5) + "" + ;
              CSTR(aAnzKEM[ 3],5) + "" + ;
              CSTR(aAnzKEM[ 4],5) + "" + ;
              CSTR(aAnzKEM[ 5],5) + "" + ;
              CSTR(aAnzKEM[ 6],5) + "" + ;
              CSTR(aAnzKEM[ 7],5) + "" + ;
              CSTR(aAnzKEM[ 8],5) + "" + ;
              CSTR(aAnzKEM[ 9],5) + "" + ;
              CSTR(aAnzKEM[10],5) + "" + ;
              CSTR(aAnzKEM[11],6) + "" + ;
              CSTR(aAnzKEM[12],6) + "" + ;
              CSTR(aAnzKEM[13],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAnzKEW),5) + "    " + ;
              CSTR(aAnzKEW[ 1],5) + "" + ;
              CSTR(aAnzKEW[ 2],5) + "" + ;
              CSTR(aAnzKEW[ 3],5) + "" + ;
              CSTR(aAnzKEW[ 4],5) + "" + ;
              CSTR(aAnzKEW[ 5],5) + "" + ;
              CSTR(aAnzKEW[ 6],5) + "" + ;
              CSTR(aAnzKEW[ 7],5) + "" + ;
              CSTR(aAnzKEW[ 8],5) + "" + ;
              CSTR(aAnzKEW[ 9],5) + "" + ;
              CSTR(aAnzKEW[10],5) + "" + ;
              CSTR(aAnzKEW[11],6) + "" + ;
              CSTR(aAnzKEW[12],6) + "" + ;
              CSTR(aAnzKEW[13],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "   ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "unehel. Kinder (m)" ; EXPORT->ANZAHL := sumArray(aAnzKUM)
   FOR i := 1 TO 10
      APPEND BLANK
      EXPORT->WERT   := ALLTRIM(STR(i))
      EXPORT->ANZAHL := aAnzKUM[i]
   NEXT
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAnzKUM[11]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAnzKUM[12]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzKUM[13]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "   ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "unehel. Kinder (f)" ; EXPORT->ANZAHL := sumArray(aAnzKUW)
   FOR i := 1 TO 10
      APPEND BLANK
      EXPORT->WERT   := ALLTRIM(STR(i))
      EXPORT->ANZAHL := aAnzKUW[i]
   NEXT
   APPEND BLANK ; EXPORT->WERT := "bis 15          "  ; EXPORT->ANZAHL := aAnzKUW[11]
   APPEND BLANK ; EXPORT->WERT := "bis 20          "  ; EXPORT->ANZAHL := aAnzKUW[12]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzKUW[13]

   PRINTZEILE("#L8")
   PRINTZEILE("^Auneheliche Kinder^B      1    2    3    4    5    6    7    8    9   10bis 15bis 20mehr ")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAnzKUM),5) + "    " + ;
              CSTR(aAnzKUM[ 1],5) + "" + ;
              CSTR(aAnzKUM[ 2],5) + "" + ;
              CSTR(aAnzKUM[ 3],5) + "" + ;
              CSTR(aAnzKUM[ 4],5) + "" + ;
              CSTR(aAnzKUM[ 5],5) + "" + ;
              CSTR(aAnzKUM[ 6],5) + "" + ;
              CSTR(aAnzKUM[ 7],5) + "" + ;
              CSTR(aAnzKUM[ 8],5) + "" + ;
              CSTR(aAnzKUM[ 9],5) + "" + ;
              CSTR(aAnzKUM[10],5) + "" + ;
              CSTR(aAnzKUM[11],6) + "" + ;
              CSTR(aAnzKUM[12],6) + "" + ;
              CSTR(aAnzKUM[13],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAnzKUW),5) + "    " + ;
              CSTR(aAnzKUW[ 1],5) + "" + ;
              CSTR(aAnzKUW[ 2],5) + "" + ;
              CSTR(aAnzKUW[ 3],5) + "" + ;
              CSTR(aAnzKUW[ 4],5) + "" + ;
              CSTR(aAnzKUW[ 5],5) + "" + ;
              CSTR(aAnzKUW[ 6],5) + "" + ;
              CSTR(aAnzKUW[ 7],5) + "" + ;
              CSTR(aAnzKUW[ 8],5) + "" + ;
              CSTR(aAnzKUW[ 9],5) + "" + ;
              CSTR(aAnzKUW[10],5) + "" + ;
              CSTR(aAnzKUW[11],6) + "" + ;
              CSTR(aAnzKUW[12],6) + "" + ;
              CSTR(aAnzKUW[13],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "ehel. Verb. (m) "  ; EXPORT->ANZAHL := sumArray(aAnzVEM)
   APPEND BLANK ; EXPORT->WERT := "1               "  ; EXPORT->ANZAHL := aAnzVEM[1]
   APPEND BLANK ; EXPORT->WERT := "2               "  ; EXPORT->ANZAHL := aAnzVEM[2]
   APPEND BLANK ; EXPORT->WERT := "3               "  ; EXPORT->ANZAHL := aAnzVEM[3]
   APPEND BLANK ; EXPORT->WERT := "4               "  ; EXPORT->ANZAHL := aAnzVEM[4]
   APPEND BLANK ; EXPORT->WERT := "5               "  ; EXPORT->ANZAHL := aAnzVEM[5]
   APPEND BLANK ; EXPORT->WERT := "6               "  ; EXPORT->ANZAHL := aAnzVEM[6]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzVEM[7]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "ehel. Verb. (f) "  ; EXPORT->ANZAHL := sumArray(aAnzVEW)
   APPEND BLANK ; EXPORT->WERT := "1               "  ; EXPORT->ANZAHL := aAnzVEW[1]
   APPEND BLANK ; EXPORT->WERT := "2               "  ; EXPORT->ANZAHL := aAnzVEW[2]
   APPEND BLANK ; EXPORT->WERT := "3               "  ; EXPORT->ANZAHL := aAnzVEW[3]
   APPEND BLANK ; EXPORT->WERT := "4               "  ; EXPORT->ANZAHL := aAnzVEW[4]
   APPEND BLANK ; EXPORT->WERT := "5               "  ; EXPORT->ANZAHL := aAnzVEW[5]
   APPEND BLANK ; EXPORT->WERT := "6               "  ; EXPORT->ANZAHL := aAnzVEW[6]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzVEW[7]

   PRINTZEILE("#L8")
   PRINTZEILE("^Aeheliche Verbindung^B    1    2    3    4    5    6mehr ")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAnzVEM),5) + "    " + ;
              CSTR(aAnzVEM[ 1],5) + "" + ;
              CSTR(aAnzVEM[ 2],5) + "" + ;
              CSTR(aAnzVEM[ 3],5) + "" + ;
              CSTR(aAnzVEM[ 4],5) + "" + ;
              CSTR(aAnzVEM[ 5],5) + "" + ;
              CSTR(aAnzVEM[ 6],5) + "" + ;
              CSTR(aAnzVEM[ 7],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAnzVEW),5) + "    " + ;
              CSTR(aAnzVEW[ 1],5) + "" + ;
              CSTR(aAnzVEW[ 2],5) + "" + ;
              CSTR(aAnzVEW[ 3],5) + "" + ;
              CSTR(aAnzVEW[ 4],5) + "" + ;
              CSTR(aAnzVEW[ 5],5) + "" + ;
              CSTR(aAnzVEW[ 6],5) + "" + ;
              CSTR(aAnzVEW[ 7],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "unehel. Verb. (m) "; EXPORT->ANZAHL := sumArray(aAnzVUM)
   APPEND BLANK ; EXPORT->WERT := "1               "  ; EXPORT->ANZAHL := aAnzVUM[1]
   APPEND BLANK ; EXPORT->WERT := "2               "  ; EXPORT->ANZAHL := aAnzVUM[2]
   APPEND BLANK ; EXPORT->WERT := "3               "  ; EXPORT->ANZAHL := aAnzVUM[3]
   APPEND BLANK ; EXPORT->WERT := "4               "  ; EXPORT->ANZAHL := aAnzVUM[4]
   APPEND BLANK ; EXPORT->WERT := "5               "  ; EXPORT->ANZAHL := aAnzVUM[5]
   APPEND BLANK ; EXPORT->WERT := "6               "  ; EXPORT->ANZAHL := aAnzVUM[6]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzVUM[7]

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "unehel. Verb. (f) "; EXPORT->ANZAHL := sumArray(aAnzVUW)
   APPEND BLANK ; EXPORT->WERT := "1               "  ; EXPORT->ANZAHL := aAnzVUW[1]
   APPEND BLANK ; EXPORT->WERT := "2               "  ; EXPORT->ANZAHL := aAnzVUW[2]
   APPEND BLANK ; EXPORT->WERT := "3               "  ; EXPORT->ANZAHL := aAnzVUW[3]
   APPEND BLANK ; EXPORT->WERT := "4               "  ; EXPORT->ANZAHL := aAnzVUW[4]
   APPEND BLANK ; EXPORT->WERT := "5               "  ; EXPORT->ANZAHL := aAnzVUW[5]
   APPEND BLANK ; EXPORT->WERT := "6               "  ; EXPORT->ANZAHL := aAnzVUW[6]
   APPEND BLANK ; EXPORT->WERT := "mehr            "  ; EXPORT->ANZAHL := aAnzVUW[7]

   PRINTZEILE("#L8")
   PRINTZEILE("^Auneheliche Verbindung^B  1    2    3    4    5    6mehr ")
   PRINTZEILE("")
   PRINTZEILE("mnnlich  " + STR(sumArray(aAnzVUM),5) + "    " + ;
              CSTR(aAnzVUM[ 1],5) + "" + ;
              CSTR(aAnzVUM[ 2],5) + "" + ;
              CSTR(aAnzVUM[ 3],5) + "" + ;
              CSTR(aAnzVUM[ 4],5) + "" + ;
              CSTR(aAnzVUM[ 5],5) + "" + ;
              CSTR(aAnzVUM[ 6],5) + "" + ;
              CSTR(aAnzVUM[ 7],5);
             )
   PRINTZEILE("")
   PRINTZEILE("weiblich  " + STR(sumArray(aAnzVUW),5) + "    " + ;
              CSTR(aAnzVUW[ 1],5) + "" + ;
              CSTR(aAnzVUW[ 2],5) + "" + ;
              CSTR(aAnzVUW[ 3],5) + "" + ;
              CSTR(aAnzVUW[ 4],5) + "" + ;
              CSTR(aAnzVUW[ 5],5) + "" + ;
              CSTR(aAnzVUW[ 6],5) + "" + ;
              CSTR(aAnzVUW[ 7],5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "Geburten        "  ; EXPORT->ANZAHL := sumArray(aGeb)
   APPEND BLANK ; EXPORT->WERT := "Januar          "  ; EXPORT->ANZAHL := aGeb[ 1]
   APPEND BLANK ; EXPORT->WERT := "Februar         "  ; EXPORT->ANZAHL := aGeb[ 2]
   APPEND BLANK ; EXPORT->WERT := "Mrz            "  ; EXPORT->ANZAHL := aGeb[ 3]
   APPEND BLANK ; EXPORT->WERT := "April           "  ; EXPORT->ANZAHL := aGeb[ 4]
   APPEND BLANK ; EXPORT->WERT := "Mai             "  ; EXPORT->ANZAHL := aGeb[ 5]
   APPEND BLANK ; EXPORT->WERT := "Juni            "  ; EXPORT->ANZAHL := aGeb[ 6]
   APPEND BLANK ; EXPORT->WERT := "Juli            "  ; EXPORT->ANZAHL := aGeb[ 7]
   APPEND BLANK ; EXPORT->WERT := "August          "  ; EXPORT->ANZAHL := aGeb[ 8]
   APPEND BLANK ; EXPORT->WERT := "September       "  ; EXPORT->ANZAHL := aGeb[ 9]
   APPEND BLANK ; EXPORT->WERT := "Oktober         "  ; EXPORT->ANZAHL := aGeb[10]
   APPEND BLANK ; EXPORT->WERT := "November        "  ; EXPORT->ANZAHL := aGeb[11]
   APPEND BLANK ; EXPORT->WERT := "Dezember        "  ; EXPORT->ANZAHL := aGeb[12]

   PRINTZEILE("#L8")
   PRINTZEILE("^ADatumsverteilung Geburt^B")
   PRINTZEILE("Anzahl Personen mit Geburtseintrgen :" + ISTR(sumArray(aGeb)))
   LEERZEILE()
   PRINTZEILE(" Jan  Feb  Mr  Apr  Mai  Jun  Jul  Aug  Sep  Okt  Nov  Dez ")
   PRINTZEILE("")

   PRINTZEILE(CSTR(aGeb[ 1] ,5) + "" + ;
              CSTR(aGeb[ 2] ,5) + "" + ;
              CSTR(aGeb[ 3] ,5) + "" + ;
              CSTR(aGeb[ 4] ,5) + "" + ;
              CSTR(aGeb[ 5] ,5) + "" + ;
              CSTR(aGeb[ 6] ,5) + "" + ;
              CSTR(aGeb[ 7] ,5) + "" + ;
              CSTR(aGeb[ 8] ,5) + "" + ;
              CSTR(aGeb[ 9] ,5) + "" + ;
              CSTR(aGeb[10] ,5) + "" + ;
              CSTR(aGeb[11] ,5) + "" + ;
              CSTR(aGeb[12] ,5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Personen        "  ; EXPORT->ANZAHL := PERSONEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "Taufen          "  ; EXPORT->ANZAHL := sumArray(aTauf)
   APPEND BLANK ; EXPORT->WERT := "Januar          "  ; EXPORT->ANZAHL := aTauf[ 1]
   APPEND BLANK ; EXPORT->WERT := "Februar         "  ; EXPORT->ANZAHL := aTauf[ 2]
   APPEND BLANK ; EXPORT->WERT := "Mrz            "  ; EXPORT->ANZAHL := aTauf[ 3]
   APPEND BLANK ; EXPORT->WERT := "April           "  ; EXPORT->ANZAHL := aTauf[ 4]
   APPEND BLANK ; EXPORT->WERT := "Mai             "  ; EXPORT->ANZAHL := aTauf[ 5]
   APPEND BLANK ; EXPORT->WERT := "Juni            "  ; EXPORT->ANZAHL := aTauf[ 6]
   APPEND BLANK ; EXPORT->WERT := "Juli            "  ; EXPORT->ANZAHL := aTauf[ 7]
   APPEND BLANK ; EXPORT->WERT := "August          "  ; EXPORT->ANZAHL := aTauf[ 8]
   APPEND BLANK ; EXPORT->WERT := "September       "  ; EXPORT->ANZAHL := aTauf[ 9]
   APPEND BLANK ; EXPORT->WERT := "Oktober         "  ; EXPORT->ANZAHL := aTauf[10]
   APPEND BLANK ; EXPORT->WERT := "November        "  ; EXPORT->ANZAHL := aTauf[11]
   APPEND BLANK ; EXPORT->WERT := "Dezember        "  ; EXPORT->ANZAHL := aTauf[12]

   PRINTZEILE("#L8")
   PRINTZEILE("^ADatumsverteilung Taufe^B")
   PRINTZEILE("Anzahl Personen mit Taufeintrgen :" + ISTR(sumArray(aTauf)))
   LEERZEILE()
   PRINTZEILE(" Jan  Feb  Mr  Apr  Mai  Jun  Jul  Aug  Sep  Okt  Nov  Dez ")
   PRINTZEILE("")

   PRINTZEILE(CSTR(aTauf[ 1] ,5) + "" + ;
              CSTR(aTauf[ 2] ,5) + "" + ;
              CSTR(aTauf[ 3] ,5) + "" + ;
              CSTR(aTauf[ 4] ,5) + "" + ;
              CSTR(aTauf[ 5] ,5) + "" + ;
              CSTR(aTauf[ 6] ,5) + "" + ;
              CSTR(aTauf[ 7] ,5) + "" + ;
              CSTR(aTauf[ 8] ,5) + "" + ;
              CSTR(aTauf[ 9] ,5) + "" + ;
              CSTR(aTauf[10] ,5) + "" + ;
              CSTR(aTauf[11] ,5) + "" + ;
              CSTR(aTauf[12] ,5);
             )
   LEERZEILE(); LEERZEILE()

   // Familienstatistik
   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Familien        "  ; EXPORT->ANZAHL := FAMILIEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "kirchl. Heiraten"  ; EXPORT->ANZAHL := sumArray(aKhei)
   APPEND BLANK ; EXPORT->WERT := "Januar          "  ; EXPORT->ANZAHL := aKhei[ 1]
   APPEND BLANK ; EXPORT->WERT := "Februar         "  ; EXPORT->ANZAHL := aKhei[ 2]
   APPEND BLANK ; EXPORT->WERT := "Mrz            "  ; EXPORT->ANZAHL := aKhei[ 3]
   APPEND BLANK ; EXPORT->WERT := "April           "  ; EXPORT->ANZAHL := aKhei[ 4]
   APPEND BLANK ; EXPORT->WERT := "Mai             "  ; EXPORT->ANZAHL := aKhei[ 5]
   APPEND BLANK ; EXPORT->WERT := "Juni            "  ; EXPORT->ANZAHL := aKhei[ 6]
   APPEND BLANK ; EXPORT->WERT := "Juli            "  ; EXPORT->ANZAHL := aKhei[ 7]
   APPEND BLANK ; EXPORT->WERT := "August          "  ; EXPORT->ANZAHL := aKhei[ 8]
   APPEND BLANK ; EXPORT->WERT := "September       "  ; EXPORT->ANZAHL := aKhei[ 9]
   APPEND BLANK ; EXPORT->WERT := "Oktober         "  ; EXPORT->ANZAHL := aKhei[10]
   APPEND BLANK ; EXPORT->WERT := "November        "  ; EXPORT->ANZAHL := aKhei[11]
   APPEND BLANK ; EXPORT->WERT := "Dezember        "  ; EXPORT->ANZAHL := aKhei[12]

   PRINTZEILE("#L8")
   PRINTZEILE("^ADatumsverteilung kirchliche Heirat^B")
   PRINTZEILE("Anzahl Familien mit kirchliche Heiratseintrgen :" + ISTR(sumArray(aKhei)))
   LEERZEILE()
   PRINTZEILE(" Jan  Feb  Mr  Apr  Mai  Jun  Jul  Aug  Sep  Okt  Nov  Dez ")
   PRINTZEILE("")

   PRINTZEILE(CSTR(aKhei[ 1] ,5) + "" + ;
              CSTR(aKhei[ 2] ,5) + "" + ;
              CSTR(aKhei[ 3] ,5) + "" + ;
              CSTR(aKhei[ 4] ,5) + "" + ;
              CSTR(aKhei[ 5] ,5) + "" + ;
              CSTR(aKhei[ 6] ,5) + "" + ;
              CSTR(aKhei[ 7] ,5) + "" + ;
              CSTR(aKhei[ 8] ,5) + "" + ;
              CSTR(aKhei[ 9] ,5) + "" + ;
              CSTR(aKhei[10] ,5) + "" + ;
              CSTR(aKhei[11] ,5) + "" + ;
              CSTR(aKhei[12] ,5);
             )
   LEERZEILE(); LEERZEILE()

   APPEND BLANK ; EXPORT->WERT := REPL("-", LEN(EXPORT->WERT)) // Trenner
   APPEND BLANK ; EXPORT->WERT := "Familien        "  ; EXPORT->ANZAHL := FAMILIEN->(LASTREC())
   APPEND BLANK ; EXPORT->WERT := "s.amtl. Heiraten"  ; EXPORT->ANZAHL := sumArray(aShei)
   APPEND BLANK ; EXPORT->WERT := "Januar          "  ; EXPORT->ANZAHL := aShei[ 1]
   APPEND BLANK ; EXPORT->WERT := "Februar         "  ; EXPORT->ANZAHL := aShei[ 2]
   APPEND BLANK ; EXPORT->WERT := "Mrz            "  ; EXPORT->ANZAHL := aShei[ 3]
   APPEND BLANK ; EXPORT->WERT := "April           "  ; EXPORT->ANZAHL := aShei[ 4]
   APPEND BLANK ; EXPORT->WERT := "Mai             "  ; EXPORT->ANZAHL := aShei[ 5]
   APPEND BLANK ; EXPORT->WERT := "Juni            "  ; EXPORT->ANZAHL := aShei[ 6]
   APPEND BLANK ; EXPORT->WERT := "Juli            "  ; EXPORT->ANZAHL := aShei[ 7]
   APPEND BLANK ; EXPORT->WERT := "August          "  ; EXPORT->ANZAHL := aShei[ 8]
   APPEND BLANK ; EXPORT->WERT := "September       "  ; EXPORT->ANZAHL := aShei[ 9]
   APPEND BLANK ; EXPORT->WERT := "Oktober         "  ; EXPORT->ANZAHL := aShei[10]
   APPEND BLANK ; EXPORT->WERT := "November        "  ; EXPORT->ANZAHL := aShei[11]
   APPEND BLANK ; EXPORT->WERT := "Dezember        "  ; EXPORT->ANZAHL := aShei[12]

   PRINTZEILE("#L8")
   PRINTZEILE("^ADatumsverteilung standesamtliche Heirat^B")
   PRINTZEILE("Anzahl Familien mit standesamtlichen Heiratseintrgen :" + ISTR(sumArray(aShei)))
   LEERZEILE()
   PRINTZEILE(" Jan  Feb  Mr  Apr  Mai  Jun  Jul  Aug  Sep  Okt  Nov  Dez ")
   PRINTZEILE("")

   PRINTZEILE(CSTR(aShei[ 1] ,5) + "" + ;
              CSTR(aShei[ 2] ,5) + "" + ;
              CSTR(aShei[ 3] ,5) + "" + ;
              CSTR(aShei[ 4] ,5) + "" + ;
              CSTR(aShei[ 5] ,5) + "" + ;
              CSTR(aShei[ 6] ,5) + "" + ;
              CSTR(aShei[ 7] ,5) + "" + ;
              CSTR(aShei[ 8] ,5) + "" + ;
              CSTR(aShei[ 9] ,5) + "" + ;
              CSTR(aShei[10] ,5) + "" + ;
              CSTR(aShei[11] ,5) + "" + ;
              CSTR(aShei[12] ,5);
             )

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                       + CRLF + ;
           "VER=" + sVer                 + CRLF + ;
           "TITEL=GENprofi^-^Statistik"  + CRLF + ;
           "Z=102"                       + CRLF,  ;
           "AW_STAT.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_STAT.DEF")
      FERASE("AW_STAT.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
static FUNCTION sumArray(a)
// ---------------------------------------------------------------------------
LOCAL i
LOCAL iRet := 0

   FOR i := 1 TO LEN(a)
      iRet += a[i]
   NEXT

RETURN(iRet)
// ---------------------------------------------------------------------------
