// ---------------------------------------------------------------------------
// Taufregister, chronologisch
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE aw_treg()
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "AW_TREG.DBF"
LOCAL sFileDbt:= "AW_TREG.DBT"
LOCAL sFileIdx:= "AW_TREG.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sPer, sName, sVname
LOCAL sDatum, sSach
LOCAL cSex, sVat, sMut

LOCAL sJahr

LOCAL fGPFok
LOCAL iRec

LOCAL i

LOCAL sPat, sPatKz
LOCAL sPaten
// ---------------------------------------------------------------------------

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Taufregister"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("AW_TREG.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"DATUM"      ,"C",   8, 0})
   AADD(aDbf, {"PERSORT"    ,"C", 150, 0})
   AADD(aDbf, {"SACH"       ,"M",  10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS AW_TREG EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON AW_TREG->DATUM + AW_TREG->PERSORT TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer     := ""
   sName    := ""
   sVname   := ""
   sDatum   := ""
   sSach    := ""
   cSex     := ""
   sVat     := ""
   sMut     := ""
   sPat     := ""
   sPaten   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF ! EMPTY(sDatum)
            SELECT AW_TREG
            APPEND BLANK
            AW_TREG->DATUM    := sDatum
            AW_TREG->PERSORT  := PADR(UPPER(sName), 60) + UPPER(sVname)
            AW_TREG->SACH     := ausg_daten(sPer, sSach, cSex, sVat, sMut, sPaten)
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         sPer     := ""
         sName    := ""
         sVname   := ""
         sDatum   := ""
         sSach    := ""
         cSex     := ""
         sVat     := ""
         sMut     := ""
         sPat     := ""
         sPaten   := ""

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.DAR.NAME"
               sPer   := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "SEX"
               cSex   := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.NAME"
               sName  := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.VNAMEN"
               sVname := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP.VAT"
               sVat   := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.KOMP.MUT"
               sMut   := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.SACH.#002"

               sDatum  := ""
               sSach   := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAR.SACH.XDAT"
                     sSach := sZeile
                  ELSEIF sTag == "GP.DAT.V"
                     sDatum := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO
            ELSEIF sTag == "GP.DAR.PAT"
               sPat     := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAR.KOMP.PAT"
                     sPat := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sPat)
                  sPaten += IF(EMPTY(sPaten), "", "; ") + sPat
               ENDIF

            ELSEIF sTag == "GP.SACH.#906"

               sPat   := ""
               sPatKz := ""

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAR.SACH"
                     sPat := sZeile
                  ELSEIF sTag == "GP.SACH.KZ"
                     sPatKz := sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF ! EMPTY(sPatKz)

                  // Die Sachgebietsdarstellung fngt mit dem Sachgebietdkennzeichen
                  // an, das sollte aber in diesem Fall entfernt werden.

                  sPat := SUBS(sPat, LEN(sPatKz) + 2)
               ENDIF

               IF ! EMPTY(sPat)
                  sPaten += IF(EMPTY(sPaten), "", "; ") + sPat
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(AW_TREG->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT AW_TREG
   GO TOP

   iRec := 1
   IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=6") ; BREAK ; ENDIF

   DO WHILE ! AW_TREG->(EOF())

      sJahr := SUBS(AW_TREG->DATUM,1,4)
      IF ! FWRITELINE(iHdlPrn, "#L3")               ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "^A" + sJahr + "^B") ; BREAK ; ENDIF

      DO WHILE ! AW_TREG->(EOF()) .AND. ;
               sJahr == SUBS(AW_TREG->DATUM,1,4)

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         // "^#" ist z.B. fr den WP Druck wichtig.  Dann wird
         // eine Einrckung gesendet, so da eine optimale Formatierung
         // mglich ist
         IF ! FWRITELINE(iHdlPrn, ausg_datum(AW_TREG->DATUM) + " ^#" + AW_TREG->SACH)
            BREAK
         ENDIF

         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 13,30 SAY STR(iRec/AW_TREG->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Taufregister"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "AW_TREG.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("AW_TREG.DEF")
      FERASE("AW_TREG.PRN")
   ENDIF

RETURN
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
static FUNCTION ausg_datum(sDatum)
// ---------------------------------------------------------------------------
LOCAL iM := VAL(SUBS(sDatum,5,2))
LOCAL iT := VAL(SUBS(sDatum,7,2))

LOCAL sRet

   IF iM > 0
      sRet := STRZERO(iM, 2)
   ELSE
      sRet := " ?"
   ENDIF

   IF iT > 0
      sRet := STRZERO(iT, 2) + "." + sRet
   ELSE
      sRet := " ?." + sRet
   ENDIF

RETURN(sRet)
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
static FUNCTION ausg_daten(sPer, sSach, cSex, sVat, sMut, sPaten)
// ---------------------------------------------------------------------------
LOCAL sRet := ""
LOCAL sPrev, sEltern

   sRet := sPer

   IF ! EMPTY(sSach)
      sRet += IF(!EMPTY(sRet), ", ", "") + sSach
   ENDIF

   // ------------------------------------------------------------------------
   // Zusammenstellung der Elterndaten
   // ------------------------------------------------------------------------
   IF cSex == "M"
      sPrev := "So. d. "
   ELSEIF cSex == "F"
      sPrev := "To. d. "
   ELSE
      sPrev := "Ki. d. "
   ENDIF

   IF ! EMPTY(sVat) .OR. ! EMPTY(sMut)
      IF ! EMPTY(sVat) .AND. ! EMPTY(sMut)
         sEltern := sPrev + sVat + " und der " + sMut
      ELSEIF ! EMPTY(sVat)
         sEltern := sPrev + sVat
      ELSE
         sEltern := sPrev + sMut
      ENDIF

      sRet += IF(! EMPTY(sRet), ", ", "") + sEltern
   ENDIF

   // ------------------------------------------------------------------------
   // Anhngen der Paten
   // ------------------------------------------------------------------------
   IF ! EMPTY(sPaten)
      sRet += IF(! EMPTY(sRet), ". ", "") + "^A^EPaten^F^B " + sPaten
   ENDIF

RETURN(sRet)
// ---------------------------------------------------------------------------


