// ---------------------------------------------------------------------------
// Programm : GP_AUSW.PRG
// Autor    : Heiko Thimm
// Stand    : 97-10-22
//
//            Programmroutinen zum GP Export Modul
// ---------------------------------------------------------------------------
// <c> 1997, Heiko Thimm
// ---------------------------------------------------------------------------
// Ich habe mich (hoffentlich) weitestgehend bemht, Standard-Clipper
// Code zu schreiben. Dies ist gar nicht so einfach, wenn man sonst auf
// eine Vielzahl von Tools zurckgreift. Dennoch wurde dieser Weg gewhlt,
// da damit eine einfache Ausgangsbasis geschaffen wird, um Programmablufe
// zu dokumentieren.
//
// Den hier vorliegenden Quell-Code haben Sie in Verbindung mit dem
// GENprofi ExportModul erhalten.
//
// Bitte beachten Sie folgende Hinweise :
// --------------------------------------
//
// 1.) Es versteht sich von selbst, da Sie diese Quellen nicht
//     weitergeben oder verffentlichen drfen.
//
// 2.) Sie drfen aber diese Quellen dazu benutzen, um eigene
//     Programme zu schreiben. Die Verwendung meiner Quellen in eigenen
//     Programmen zum eigenen Gebrauch oder bei Weitergabe fr eine
//     Bearbeitungsgebhr sind keine Lizenzabgaben an mich fllig.
//
// 3.) Sofern Sie als Entwickler eigene Programme fr GENprofi entwickeln
//     und meine Quellen verwenden, so mssen Sie auf der/den
//     Programmdisketten folgenden Hinweis anbringen :
//
//        Teile : <c> 1997, Heiko Thimm, Birnbach
//
// ---------------------------------------------------------------------------

#include "std.ch"


// ---------------------------------------------------------------------------
PROCEDURE hauptmaske(_prog, _sc)
// ---------------------------------------------------------------------------

   IF VALTYPE(_sc)   != "C" ; _sc   := "" ; ENDIF
   IF VALTYPE(_prog) != "C" ; _prog := "" ; ENDIF

   SETCOLOR(MEMVAR->sColScr)
   CLS
   SETCOLOR(MEMVAR->sColKopf)
   @  0,0 SAY PADR(_prog,80)
   @  1,0 SAY PADR(_sc,80)
   @ 24,0 SAY PADR("",80)
   SETCOLOR(MEMVAR->sColScr)
   @  2,0 SAY REPL("",80)
   @ 23,0 SAY REPL("",80)

RETURN
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
PROCEDURE meldung(_s)
// ---------------------------------------------------------------------------
LOCAL _sc := SETCOLOR()                   // Farbsetzung merken
// ---------------------------------------------------------------------------
   IF VALTYPE(_s) != "C" ; _s = "" ; ENDIF

   SETCOLOR(MEMVAR->sColKopf)
   @ 24,00 SAY PADR(_s,80)                // Meldung ausgeben
   SETCOLOR(_sc)                          // Farbwert restaurieren

RETURN
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
FUNCTION fehler(sMessage)
// ---------------------------------------------------------------------------
   IF "C" != VALTYPE(sMessage) ; sMessage := "" ; ENDIF

   TONE(440,2)

   ALERT(sMessage, {"Ok"})

RETURN (.F.)
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
FUNCTION frage(sMessage)
// ---------------------------------------------------------------------------
   IF "C" != VALTYPE(sMessage) ; sMessage := "" ; ENDIF

   TONE(440,2)

RETURN (ALERT(sMessage, {"Ja", "Nein"}) == 1)
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
PROCEDURE Std_Color (bColor)
// ---------------------------------------------------------------------------
PUBLIC sColScr, sColVal, sColInp, sColMen, sColLin, ;
       sColKopf, sColErr, sColDec
// ---------------------------------------------------------------------------

   IF VALTYPE(bColor) != "L" ; bColor := .T. ; ENDIF

   IF bColor .AND. ISCOLOR()          && Farbbildschirm
      MEMVAR->sColScr = "+W/B"                && Farbe der Hauptmaske
      MEMVAR->sColVal = "GR+/B"               && Farbe der Parameter
      MEMVAR->sColInp = "B/BG, +W/W,,,+W/BG"  && Eingabemaske
      MEMVAR->sColMen = "+W/W,GR+/B,,,+W/W"   && Men-Farbe
      MEMVAR->sColLin = "+W/R"                && Lesehilfe
      MEMVAR->sColErr = "GR+/R"               && Fehler
      MEMVAR->sColKopf= "B/BG"                && Kopfzeile
      MEMVAR->sColDec = "GR+/W"               && Abfrage J/N
   ELSE
      MEMVAR->sColScr = "W/N"
      MEMVAR->sColVal = "W+/N"
      MEMVAR->sColInp = "W/N,N/W,,,N/W"
      MEMVAR->sColMen = "W/N,N/W,,,W/N"
      MEMVAR->sColLin = "U"
      MEMVAR->sColErr = "N/W"                && Fehler
      MEMVAR->sColKopf= "N/W"
      MEMVAR->sColDec = "+W/N"               && Abfrage J/N
   ENDIF

RETURN
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
PROCEDURE set_init
// ---------------------------------------------------------------------------

   SET EXCLUSIVE ON
   SET ESCAPE ON
   SET INTENSITY ON
   SET CENTURY ON
   SET DATE GERMAN
   SET CONFIRM ON
   SET DELETED OFF
   SET MESSAGE TO 0
   SET WRAP ON
   SET CURSOR OFF
   SET SCOREBOARD OFF
   SET TYPEAHEAD TO 30
   SET EXACT ON

RETURN
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
PROCEDURE prog_ende(fErrorlevel)
// ---------------------------------------------------------------------------

   IF VALTYPE(fErrorlevel) == "L" ; ERRORLEVEL( IF(fErrorlevel,0,1) ) ; ENDIF

   CLOSE ALL
   SET COLOR TO W
   CLS
   SET CURSOR ON
   QUIT

RETURN
// ---------------------------------------------------------------------------


FUNCTION ISTR(i)
RETURN( ALLTRIM(STR(i)))


// --------------------------------------------------------------------------
FUNCTION STRFILE(_s, _sFile)
// --------------------------------------------------------------------------
// Diese Funktion schreibt einen String in eine Datei. Sofern die Datei
// bereits existiert, wird sie ohne Vorwarnung berschrieben!
// Verwendung an Stelle von MEMOWRITE.
// --------------------------------------------------------------------------
LOCAL _iHdl, _iLen
LOCAL _fRet := .F.

   IF VALTYPE(_s)     != "C" ; RETURN(.F.) ; ENDIF
   IF VALTYPE(_sFile) != "C" ; RETURN(.F.) ; ENDIF
   _iLen := LEN(_s)

   _iHdl := FCREATE(_sFile)
   IF _iHdl > 0
      _fRet := (FWRITE(_iHdl, _s, _iLen) = _iLen)
      FCLOSE(_iHdl)
   ENDIF

RETURN(_fRet)
// --------------------------------------------------------------------------


 // -----------------------------------------------------------------------
FUNCTION FREADLINE(_iHdl, _s)
// -----------------------------------------------------------------------
LOCAL _fRet := .F.
LOCAL _fNotEof
LOCAL _c    := " "

   _s := ""

   DO WHILE .T.
      IF FREAD(_iHdl, @_c, 1) > 0

         DO CASE
         CASE ASC(_c) = 13
            _fRet := .T.
            EXIT
         CASE ASC(_c) > 31 .OR. ASC(_c) = 21     // 21 =  Paragraphenzeichen
            _s += _c
         ENDCASE
      ELSE
         IF LEN(_s) > 0
            _fRet := .T.
         ENDIF
         EXIT
      ENDIF
   ENDDO

RETURN(_fRet)
// -----------------------------------------------------------------------


// -----------------------------------------------------------------------
FUNCTION FWRITELINE(_iHdl, _s)
// -----------------------------------------------------------------------
LOCAL _fRet
LOCAL _iLen
// -----------------------------------------------------------------------
   IF VALTYPE(_iHdl) != "N" ; RETURN(.F.)      ; ENDIF
   IF ! VALTYPE(_s)  $ "CM" ; _s := ""         ; ENDIF

   _fRet := FWRITE(_iHdl, _s+CRLF) = LEN(_s) + 2

RETURN(_fRet)
// -----------------------------------------------------------------------


// -----------------------------------------------------------------------
FUNCTION FWRITESTR(_iHdl, _s)
// -----------------------------------------------------------------------
LOCAL _fRet
LOCAL _iLen
// -----------------------------------------------------------------------
   IF VALTYPE(_iHdl) != "N" ; RETURN(.F.)      ; ENDIF
   IF ! VALTYPE(_s)  $ "CM" ; _s := ""         ; ENDIF

   _fRet := FWRITE(_iHdl, _s) = LEN(_s)

RETURN(_fRet)
// -----------------------------------------------------------------------


// -----------------------------------------------------------------------
FUNCTION GDFTAGLINE(iHdl, cLevel, sTag, sZeile)
// -----------------------------------------------------------------------
// Das geht natrlich viel eleganter ber TOKEN, aber die stehen im
// Standard-Clipper nicht zur Verfgung ...
//
// Eine Zeile besteht in der Regel aus <Level Tag Wert>, wobei die
// einzelnen Blcke durch Leerzeichen getrennt werden.
//
// Diese Funktion ermittelt das Tag und den Wert.
// -----------------------------------------------------------------------
LOCAL c, i, iLen
LOCAL fGPFok
// -----------------------------------------------------------------------
   fGPFok   := FREADLINE(iHdl, @sZeile)

   sZeile   := LTRIM(sZeile)           // fhrende Leerzeichen entfernen
   cLevel   := SUBS(sZeile, 1, AT(" ", sZeile) - 1)

   sZeile   := LTRIM(SUBS(sZeile,AT(" ", sZeile) + 1))

   iLen     := LEN(sZeile)
   i        := 1
   sTag     := ""

   DO WHILE (c := SUBS(sZeile, i, 1)) != " "
      sTag += c ; i++
   ENDDO

   sTag     := UPPER(sTag)
   sZeile   := LTRIM(SUBS(sZeile,i+1))

   IF cLevel == "0"
      IF "@" $ sTag
         c      := SUBS(sTag,2,LEN(sTag)-2)
         sTag   := UPPER(sZeile)
         sZeile := c
      ENDIF
   ENDIF

RETURN(fGPFok)
// -----------------------------------------------------------------------









