// ---------------------------------------------------------------------------
// Namen - Zeitraum
//
// Mischung aus Namenzhlen und Name-Orte-Zeitraum, nur mit Ignorieren
// der Ortswerte. Ausfhrliche Beschreibung in GENprofi Report
// Ausgabe 2/97
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE th639_1(sParaCol)
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "GPDATA.DBF"
LOCAL sFileIdx:= "GPDATA.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag
LOCAL sName, sNamTyp
LOCAL iJahr

LOCAL fGPFok
LOCAL iRec

LOCAL aNamen  := {}
LOCAL aDatum  := {}
LOCAL i,j

LOCAL sListTyp
// ---------------------------------------------------------------------------
   set_init()                             // Systemeinstellungen

   IF VALTYPE(sParaCol) == "C"            // Egal welcher Wert, immer SW
      std_color(.F.)
   ELSE
      std_color()                         // Dann erkenne mal schn selber ...
   ENDIF

   hauptmaske("GENPROFI Export                                                     Auswertungen", ;
              "Projekt Name-Zeitraumauswertung aus GENprofi Report 2/97             Version : 1")
   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Name - Zeitraum Auswertung"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Analyse"
   @ 14,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("GPDATA.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"NAME"   ,"C", 60, 0})
   AADD(aDbf, {"ZNAM"   ,"N", 10, 0})
   AADD(aDbf, {"ZANG"   ,"N", 10, 0})
   AADD(aDbf, {"ZSON"   ,"N", 10, 0})
   AADD(aDbf, {"VON"    ,"N",  4, 0})
   AADD(aDbf, {"BIS"    ,"N",  4, 0})

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS GPDATA EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(GPDATA->NAME) TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer   := .F.
   sTag   := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz


         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF LEN(aNamen) > 0 .AND. ;
            LEN(aDatum) > 0

            SELECT GPDATA
            FOR i := 1 TO LEN(aNamen)
               FOR j := 1 TO LEN(aDatum)
                  SEEK PADR(UPPER(aNamen[i]), 60)

                  IF ! FOUND()
                     APPEND BLANK
                     GPDATA->NAME := aNamen[i]
                     GPDATA->VON  := aDatum[j]
                  ELSE
                     IF EMPTY(GPDATA->VON)
                        GPDATA->VON  := aDatum[j]
                     ELSEIF EMPTY(GPDATA->BIS)
                        IF GPDATA->VON < aDatum[j]
                           GPDATA->BIS := aDatum[j]
                        ELSEIF GPDATA->VON > aDatum[j]
                           GPDATA->BIS := GPDATA->VON
                           GPDATA->VON := aDatum[j]
                        ENDIF
                     ENDIF
                  ENDIF
               NEXT  // j, aDatum
            NEXT  // i, aNamen
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         aNamen := {} ; aDatum  := {}

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.NAME"
               IF "," $ sZeile         // Namenszustze und Adelstitel ignorieren
                  sZeile := PADR(SUBS(sZeile, 1, AT(",", sZeile)-1), 60)
               ELSE
                  sZeile := PADR(sZeile, 60)
               ENDIF

               IF ! EMPTY(sZeile)
                  sName := sZeile

                  // Wenn kein Namentyp angegeben wurde, automatisch
                  // auf Geburtsnamen setzen
                  sNamTyp := "#0"

                  // Alle Eintrge zum Namen abarbeiten ...
                  cAltLevel := cLevel
                  fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

                  DO WHILE cAltLevel < cLevel .AND. fGPFok
                     IF sTag == "GP.NAME.TYP"
                        sNamTyp := sZeile
                     ENDIF
                     fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
                  ENDDO

                  // Bestimmte Namentypen werden unterdrckt, da die
                  // Aufnahme in diese Auswertung sinnlos wre

                  IF sNamTyp != "#1" .AND. ;    // Stamname
                     sNamTyp != "#H" .AND. ;    // Stamm : a.d.H.
                     sNamTyp != "#2" .AND. ;    // vorangest. Adelstitel
                     sNamTyp != "#B" .AND. ;    // Beiname
                     ! EMPTY(sName)             // na ja, und ein Name mu schon da sein

                     AADD(aNamen, sName)         // in Zwischenspeicher bernehmen

                     SELECT GPDATA
                     SEEK UPPER(sName)

                     IF ! FOUND()
                        APPEND BLANK
                        GPDATA->NAME := sName
                     ENDIF

                     IF sNamTyp == "#0" .OR. ;  // Geburtsname
                        sNamTyp == "#3" .OR. ;  // weitere Namen
                        sNamTyp == "#4" .OR. ;  // weitere Namen, Form 2
                        sNamTyp == "#P" .OR. ;  // Patronym
                        sNamTyp == "#G" .OR. ;  // genannt
                        sNamTyp == "#S"         // Schreibweise

                        GPDATA->ZNAM := GPDATA->ZNAM + 1
                     ELSEIF sNamTyp == "#A" .OR. ;     // Adoption
                              sNamTyp == "#N" .OR. ;   // Namennderung
                              sNamTyp == "#V"          // Name durch Heirat angenommen
                        GPDATA->ZANG := GPDATA->ZANG + 1
                     ELSE                              // der ganze Rest
                        GPDATA->ZSON := GPDATA->ZSON + 1
                     ENDIF
                  ENDIF
               ENDIF
            ELSEIF SUBS(sTag,1,7) == "GP.SACH"

               // Alle Eintrge zum Sachgebiet abarbeiten ...
               iJahr := 0

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAT.V"
                     iJahr := VAL(SUBS(sZeile,1,4))
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

               IF iJahr > 0
                  AADD(aDatum, iJahr)            // in Zwischenspeicher bernehmen
               ENDIF
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(GPDATA->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT GPDATA
   GO TOP

   iRec := 1

   // ---------------------------------------------------------------------------
   // Alle Namen
   // ---------------------------------------------------------------------------
   DO WHILE ! GPDATA->(EOF())

      // "#SATZNR" gibt die lfd. Nummer an.
      // Auf diese Angabe knnte verzichtet werden, aber so ist die
      // Ausgabe vollstndig.
      IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

      // ^# wird z.:B. fr WordPerfect Druck in TAB umgesetzt!
      sZeile := PADR(GPDATA->NAME, 60)

      IF GPDATA->ZNAM > 9            // dann den Namen <fett> drucken
         sZeile := "^A" + sZeile + "^B"
      ENDIF

      sZeile := sZeile + "    ^#" +;
                IF(!EMPTY(GPDATA->VON),STR(GPDATA->VON, 4),SPACE(4)) + "  ^#" + ;
                IF(!EMPTY(GPDATA->BIS),STR(GPDATA->BIS, 4),SPACE(4)) + "  ^#"

      sZeile += "(" + ISTR(GPDATA->ZNAM)

      IF GPDATA->ZSON > 0
         sZeile += "/" + ISTR(GPDATA->ZANG) + ;
                   "/" + ISTR(GPDATA->ZSON)

      ELSEIF GPDATA->ZANG > 0
         sZeile += "/" + ISTR(GPDATA->ZANG)
      ENDIF

      sZeile += ")"

      IF ! FWRITELINE(iHdlPrn, sZeile)
         BREAK
      ENDIF

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF

      iRec ++
      SKIP

      @ 14,30 SAY STR(iRec/GPDATA->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 14,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                   + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Namen^-^Zeitraum^Auswertung"  + CRLF + ;
           "Z=92"                   + CRLF,  ;
           "GPDATA.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("GPDATA.DEF")
      FERASE("GPDATA.PRN")
   ENDIF

   prog_ende()

RETURN
// ---------------------------------------------------------------------------
