// ---------------------------------------------------------------------------
// Taufregister in Originalreihenfolge mit Originaltext
// fr MAUS/Bremen
// ---------------------------------------------------------------------------

#include "std.ch"

// ---------------------------------------------------------------------------
PROCEDURE th639_2(sParaCol)
// ---------------------------------------------------------------------------
LOCAL sVer    := "1.0"

LOCAL iHdl    := 0
LOCAL iHdlPrn := 0
LOCAL aDbf    := {}
LOCAL sFile   := "GPDATA.DBF"
LOCAL sFileDBT:= "GPDATA.DBT"
LOCAL sFileIdx:= "GPDATA.NTX"
LOCAL iFileSize

LOCAL fOk     := .F.

LOCAL sZeile  := ""
LOCAL iPer    := 0

LOCAL fPer, cLevel, cAltLevel, sTag

LOCAL fGPFok
LOCAL iRec

LOCAL i,j

LOCAL sPer, sVat, sMut, sQ, sQ_S, sQ_P, sQ_Text, sPat

LOCAL sListTyp
// ---------------------------------------------------------------------------
   set_init()                             // Systemeinstellungen

   IF VALTYPE(sParaCol) == "C"            // Egal welcher Wert, immer SW
      std_color(.F.)
   ELSE
      std_color()                         // Dann erkenne mal schn selber ...
   ENDIF

   hauptmaske("GENPROFI Export                                                     Auswertungen", ;
              "Taufregister in Originalreihenfolge  (Die Maus)                      Version : 1")
   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 4,0  SAY "Taufregister in Originalreihenfolge"
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   // ------------------------------------------------------------------------
   // Hinweise auf aktuelles Programm-Modul
   // ------------------------------------------------------------------------
   SETCOLOR(MEMVAR->sColScr)
   @ 5,0  SAY "Modulversion"          ; @ 5,30 SAY sVer

   @ 7,0  SAY "Auswertungsdateigre"
   @ 8,0  SAY "Stand der Auswertung"

   @ 10,0 SAY "Anzahl Personen"

   @ 12,0 SAY "Anzahl Eintrge"
   @ 13,0 SAY "Stand der Ausgabe"

   BEGIN SEQUENCE                      // Dies ist sehr praktisch ...

   // ------------------------------------------------------------------------
   // Exportdatei ffnen ...
   // ------------------------------------------------------------------------
   IF ! FILE("EXPORT\GPEXP.GDF")
      fehler("Datei 'EXPORT\GPEXP.GDF' nicht vorhanden. Abbruch!")
      BREAK
   ENDIF

   iHdl := FOPEN("EXPORT\GPEXP.GDF")

   IF iHdl < 1
      fehler("Datei 'EXPORT\GPEXP.GDF' konnte nicht gffnet werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Dateigre ermitteln ...
   // ------------------------------------------------------------------------
   iFileSize := FSEEK(iHdl, 0, 2)  ; FSEEK(iHdl, 0, 0)
   @ 7,30 SAY STR(iFileSize, 15, 0)

   // ------------------------------------------------------------------------
   // Druckdatei erzeugen ...
   // ------------------------------------------------------------------------
   iHdlPrn := FCREATE("GPDATA.PRN")

   IF iHdlPrn < 1
      fehler("Druckdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Hilfsdatei erzeugen ...
   // ------------------------------------------------------------------------
   FERASE(sFile)                       // eventuelle Reste entfernen

   aDbf  := {}
   AADD(aDbf, {"QUELLE"     ,"C",  60, 0})
   AADD(aDbf, {"SEITE"      ,"C",   6, 0})
   AADD(aDbf, {"POS"        ,"C",   5, 0})
   AADD(aDbf, {"PERSON"     ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"VATER"      ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"MUTTER"     ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"PATEN"      ,"M",  10, 0})   // Memofeld
   AADD(aDbf, {"ORIG"       ,"M",  10, 0})   // Memofeld

   DBCREATE(sFile, aDbf)

   IF FILE(sFile)
      USE (sFile) ALIAS GPDATA EXCLUSIVE NEW
      IF NETERR()
         fehler("Hilfsdatei konnte nicht geffnet werden. Abbruch!")
         BREAK
      ENDIF
      INDEX ON UPPER(GPDATA->QUELLE)  + GPDATA->SEITE + GPDATA->POS TO (sFileIdx)
   ELSE
      fehler("Hilfsdatei konnte nicht erzeugt werden. Abbruch!")
      BREAK
   ENDIF

   // ------------------------------------------------------------------------
   // Einlesen der Daten ...
   // ------------------------------------------------------------------------
   fPer     := .F.
   sTag     := ""
   sPer := sVat := sMut := sQ := sQ_S := sQ_P := sQ_Text := sPat := ""

   fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

   DO WHILE fGPFok

      IF cLevel == "0"                 // Hauptsatz

         // ------------------------------------------------------------------
         // Umsetzen der bisherigen Werte ...
         // ------------------------------------------------------------------
         IF ! EMPTY(sQ)
            APPEND BLANK
            GPDATA->QUELLE   := sQ
            GPDATA->SEITE    := STR(VAL(sQ_S),6)
            GPDATA->POS      := STR(VAL(sQ_P),5)
            GPDATA->PERSON   := sPer
            GPDATA->VATER    := sVat
            GPDATA->MUTTER   := sMut
            GPDATA->PATEN    := sPat
            GPDATA->ORIG     := sQ_Text
         ENDIF

         // ------------------------------------------------------------------
         // Zurcksetzen der Zwischenspeicher
         // ------------------------------------------------------------------
         sPer := sVat := sMut := sQ := sQ_S := sQ_P := sQ_Text := sPat := ""

         IF sTag == "TRLR"             // Dateiende
            EXIT
         ELSEIF sTag == "INDI"         // Personen
            fPer := .T.
            iPer++
         ELSE                          // Ignorieren
            fPer := .F.
         ENDIF
         fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
      ELSE
         IF fPer                       // nur Personen analysieren
            IF sTag == "GP.DAR.UEB"
               sPer := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB.VAT"
               sVat := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB.MUT"
               sMut := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.DAR.UEB.PAT"
               IF EMPTY(sPat)
                  sPat += sZeile
               ELSE
                  sPat +=  "; " + sZeile
               ENDIF
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.Q.QUELLE"
               sQ := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.Q.SEITE"
               sQ_S := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.Q.POS"
               sQ_P := sZeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ELSEIF sTag == "GP.Q.ORIG"
               sQ_Text := sZeile

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "CONT"
                     sQ_Text += CHR(13) + sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

            ELSEIF sTag == "GP.Q.KOMM"

               IF ! EMPTY(sQ_Text)
                  sQ_Text += CHR(13) + sZeile
               ELSE
                  sQ_Text := sZeile
               ENDIF

               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "CONT"
                     sQ_Text += CHR(13) + sZeile
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO

            ELSEIF sTag == "GP.SACH.#906"

               // Alle Eintrge zum pateneintrag abarbeiten ...
               cAltLevel := cLevel
               fGPFok    := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)

               DO WHILE cAltLevel < cLevel .AND. fGPFok
                  IF sTag == "GP.DAR.SACH"

                     IF EMPTY(sPat)
                        sPat += sZeile
                     ELSE
                        sPat +=  "; " + sZeile
                     ENDIF
                  ENDIF
                  fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
               ENDDO
            ELSE                                 // nchste Zeile
               fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
            ENDIF
         ELSE
            fGPFok := GDFTAGLINE(iHdl, @cLevel, @sTag, @sZeile)
         ENDIF
      ENDIF

      @  8,30 SAY STR(FSEEK(iHdl,0,1)/iFileSize * 100, 14) + "%"
      @ 10,30 SAY STR(iPer, 15, 0)
      @ 12,30 SAY STR(GPDATA->(LASTREC()), 15, 0)

      // ------------------------------------------------------------------------
      // Mit ESC kann der ganze Zauber abgebrochen werden
      // ------------------------------------------------------------------------
      IF INKEY() == 27 ; BREAK ; ENDIF
   ENDDO
   @  8,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Ausdruck ...
   // ---------------------------------------------------------------------------
   SELECT GPDATA
   GO TOP

   iRec := 1

   DO WHILE ! GPDATA->(EOF())

      IF ! FWRITELINE(iHdlPrn, "#R")      // Absatzformatierungen zurcksetzen
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=0")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "^A" + ALLTRIM(GPDATA->QUELLE) + "^B")
         BREAK
      ENDIF
      IF ! FWRITELINE(iHdlPrn, "")   ; BREAK ; ENDIF

      IF ! FWRITELINE(iHdlPrn, "#ABS_LR=4")   ; BREAK ; ENDIF
      IF ! FWRITELINE(iHdlPrn, "#ABS_LRFL=2") ; BREAK ; ENDIF

      sQ := UPPER(GPDATA->QUELLE)

      DO WHILE ! GPDATA->(EOF()) .AND. ;
               sQ == UPPER(GPDATA->QUELLE)

         // "#SATZNR" gibt die lfd. Nummer an.
         // Auf diese Angabe knnte verzichtet werden, aber so ist die
         // Ausgabe vollstndig.
         IF ! FWRITELINE(iHdlPrn, "#SATZNR="+ISTR(iRec)) ; BREAK ; ENDIF

         // "^#" ist z.B. fr den WP Druck wichtig.  Dann wird
         // eine Einrckung gesendet, so da eine optimale Formatierung
         // mglich ist
         IF ! EMPTY(GPDATA->POS)
            IF ! FWRITELINE(iHdlPrn, PADR(ALLTRIM(GPDATA->SEITE) + "/" + ALLTRIM(GPDATA->POS),12) + "^#" +;
                                     GPDATA->PERSON) ; BREAK ; ENDIF
         ELSE
            IF ! FWRITELINE(iHdlPrn, PADR(ALLTRIM(GPDATA->SEITE), 12) + "^#" +;
                                     GPDATA->PERSON) ; BREAK ; ENDIF
         ENDIF

         IF ! EMPTY(GPDATA->VATER)
            IF ! FWRITELINE(iHdlPrn, SPACE(12) + "^#^AVater :^B  ^#" + GPDATA->VATER) ; BREAK ; ENDIF
         ENDIF
         IF ! EMPTY(GPDATA->MUTTER)
            IF ! FWRITELINE(iHdlPrn, SPACE(12) + "^#^AMutter :  ^B^#" + GPDATA->MUTTER) ; BREAK ; ENDIF
         ENDIF
         IF ! EMPTY(GPDATA->PATEN)
            IF ! FWRITELINE(iHdlPrn, SPACE(12) + "^#^APaten  :  ^B^#" + GPDATA->PATEN)  ; BREAK ; ENDIF
         ENDIF

         IF ! EMPTY(GPDATA->ORIG)
            IF ! FWRITELINE(iHdlPrn, "#ABS_RED=J")   ; BREAK ; ENDIF
            fPrintText(iHdlPrn, GPDATA->ORIG, SPACE(12) + "^#")
            IF ! FWRITELINE(iHdlPrn, "#ABS_RED=N")   ; BREAK ; ENDIF
         ENDIF

         IF INKEY() == 27 ; BREAK ; ENDIF
         iRec ++
         SKIP
      ENDDO

      IF ! FWRITELINE(iHdlPrn, "") ; BREAK ; ENDIF
      @ 13,30 SAY STR(iRec/GPDATA->(LASTREC()) * 100, 14) + "%"
   ENDDO
   @ 13,30 SAY STR(100, 15) + "%"      // nur zur Nervenberuhigung

   // ---------------------------------------------------------------------------
   // Erzeugen der Definitionsdatei fr den Ausdruck ber GP_PRN FASC
   // ---------------------------------------------------------------------------
   STRFILE("FRM=2"                  + CRLF + ;
           "VER=" + sVer            + CRLF + ;
           "TITEL=Originalreihenfolge^Taufregister"  + CRLF + ;
           "Z=92"                   + CRLF,  ;    // zus.  Luft
           "GPDATA.DEF")

   fOk := .T.                          // Alles ist durchgelaufen

   END SEQUENCE

   // ---------------------------------------------------------------------------
   // Aufrumen
   // ---------------------------------------------------------------------------

   CLOSE ALL                           // Alle Datenbanken werden geschlossen

   FERASE(sFile)                       // Hilfsdatei wird nicht mehr bentigt
   FERASE(sFileIdx)
   FERASE(sFileDbt)
   FCLOSE(iHdl)
   FCLOSE(iHdlPrn)

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("GPDATA.DEF")
      FERASE("GPDATA.PRN")
   ENDIF

   SETCOLOR(MEMVAR->sColScr)           // Bildschirm wieder aufrumen
   @ 4,0 CLEAR TO 22,79

   IF ! fOk                            // Abbruch oder Fehler
      // Dann mssen eventuelle Reste der Druckdateien entfernt werden!
      FERASE("GPDATA.DEF")
      FERASE("GPDATA.PRN")
   ENDIF

   prog_ende()

RETURN
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
PROCEDURE fPrintText(iHdlPrn, sText, sVorAbsatz)
// ---------------------------------------------------------------------------
// Jeder Absatz wird durch CHR(13) beendet. Jeder Absatz wird durch
// sVorAbsatz eingeleitet.
// ---------------------------------------------------------------------------
LOCAL sAbsatz, iPos

   IF VALTYPE(iHdlPrn) != "N"   ; RETURN ; ENDIF   // keine Druckdatei
   IF ! VALTYPE(sText) $ "CM"   ; RETURN ; ENDIF   // Kein Text - keine Ausgabe
   IF EMPTY(sText)              ; RETURN ; ENDIF
   IF VALTYPE(sVorAbsatz) != "C"; sVorAbsatz := "" ; ENDIF
   // ------------------------------------------------------------------------

   DO WHILE (iPos := AT(CHR(13), sText))   > 0
      sAbsatz := SUBS(sText, 1, iPos - 1)
      sText   := SUBS(sText, iPos + 1)
      IF ! FWRITELINE(iHdlPrn, sVorAbsatz + sAbsatz) ; BREAK ; ENDIF
   ENDDO
   IF ! FWRITELINE(iHdlPrn, sVorAbsatz + sText) ; BREAK ; ENDIF

RETURN
// ---------------------------------------------------------------------------
